/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "CSSFontFaceLoadEvent.h"
#include "CSSFontFaceLoadEventBinding.h"
#include "EventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/CSSFontFaceLoadEvent.h"
#include "mozilla/dom/FontFace.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(CSSFontFaceLoadEvent)

NS_IMPL_ADDREF_INHERITED(CSSFontFaceLoadEvent, Event)
NS_IMPL_RELEASE_INHERITED(CSSFontFaceLoadEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(CSSFontFaceLoadEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mFontfaces)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(CSSFontFaceLoadEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(CSSFontFaceLoadEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mFontfaces)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(CSSFontFaceLoadEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

CSSFontFaceLoadEvent::CSSFontFaceLoadEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

CSSFontFaceLoadEvent::~CSSFontFaceLoadEvent()
{
}

CSSFontFaceLoadEvent*
CSSFontFaceLoadEvent::AsCSSFontFaceLoadEvent()
{
  return this;
}

JSObject*
CSSFontFaceLoadEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return CSSFontFaceLoadEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<CSSFontFaceLoadEvent>
CSSFontFaceLoadEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const CSSFontFaceLoadEventInit& aEventInitDict)
{
  nsRefPtr<CSSFontFaceLoadEvent> e = new CSSFontFaceLoadEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mFontfaces.AppendElements(aEventInitDict.mFontfaces);
  e->SetTrusted(trusted);
  return e.forget();
}

already_AddRefed<CSSFontFaceLoadEvent>
CSSFontFaceLoadEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const CSSFontFaceLoadEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

void
CSSFontFaceLoadEvent::GetFontfaces(nsTArray<nsRefPtr<FontFace>>& aRetVal) const
{
  aRetVal = mFontfaces;
}


} // namespace dom
} // namespace mozilla
