/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "AtomList.h"
#include "KeyboardEventBinding.h"
#include "UIEventBinding.h"
#include "WrapperFactory.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/KeyboardEvent.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/OwningNonNull.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"
#include "nsGlobalWindow.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {


KeyboardEventInit::KeyboardEventInit()
  : EventModifierInit(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
KeyboardEventInit::InitIds(JSContext* cx, KeyboardEventInitAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->which_id.init(cx, "which") ||
      !atomsCache->repeat_id.init(cx, "repeat") ||
      !atomsCache->location_id.init(cx, "location") ||
      !atomsCache->keyCode_id.init(cx, "keyCode") ||
      !atomsCache->key_id.init(cx, "key") ||
      !atomsCache->isComposing_id.init(cx, "isComposing") ||
      !atomsCache->code_id.init(cx, "code") ||
      !atomsCache->charCode_id.init(cx, "charCode")) {
    return false;
  }
  return true;
}

bool
KeyboardEventInit::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  KeyboardEventInitAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<KeyboardEventInitAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  // Per spec, we init the parent's members first
  if (!EventModifierInit::Init(cx, val)) {
    return false;
  }
  MOZ_ASSERT(IsConvertibleToDictionary(cx, val));

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->charCode_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &mCharCode)) {
      return false;
    }
  } else {
    mCharCode = 0U;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->code_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mCode)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 0 };
    mCode.Rebind(data, ArrayLength(data) - 1);
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isComposing_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &mIsComposing)) {
      return false;
    }
  } else {
    mIsComposing = false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->key_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mKey)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 0 };
    mKey.Rebind(data, ArrayLength(data) - 1);
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->keyCode_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &mKeyCode)) {
      return false;
    }
  } else {
    mKeyCode = 0U;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->location_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &mLocation)) {
      return false;
    }
  } else {
    mLocation = 0U;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->repeat_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &mRepeat)) {
      return false;
    }
  } else {
    mRepeat = false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->which_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &mWhich)) {
      return false;
    }
  } else {
    mWhich = 0U;
  }
  return true;
}

bool
KeyboardEventInit::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
KeyboardEventInit::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  KeyboardEventInitAtoms* atomsCache = GetAtomCache<KeyboardEventInitAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  // Per spec, we define the parent's members first
  if (!EventModifierInit::ToObjectInternal(cx, rval)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &rval.toObject());

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint32_t const & currentValue = mCharCode;
    temp.setNumber(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->charCode_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mCode;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->code_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    bool const & currentValue = mIsComposing;
    temp.setBoolean(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->isComposing_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mKey;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->key_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint32_t const & currentValue = mKeyCode;
    temp.setNumber(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->keyCode_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint32_t const & currentValue = mLocation;
    temp.setNumber(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->location_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    bool const & currentValue = mRepeat;
    temp.setBoolean(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->repeat_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint32_t const & currentValue = mWhich;
    temp.setNumber(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->which_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
KeyboardEventInit::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
KeyboardEventInit::TraceDictionary(JSTracer* trc)
{
  EventModifierInit::TraceDictionary(trc);
}

void
KeyboardEventInit::operator=(const KeyboardEventInit& aOther)
{
  EventModifierInit::operator=(aOther);
  mCharCode = aOther.mCharCode;
  mCode = aOther.mCode;
  mIsComposing = aOther.mIsComposing;
  mKey = aOther.mKey;
  mKeyCode = aOther.mKeyCode;
  mLocation = aOther.mLocation;
  mRepeat = aOther.mRepeat;
  mWhich = aOther.mWhich;
}

namespace binding_detail {
} // namespace binding_detail


namespace KeyboardEventBinding {

static_assert(IsRefcounted<NativeType>::value == IsRefcounted<UIEventBinding::NativeType>::value,
              "Can't inherit from an interface with a different ownership model.");

static bool
get_charCode(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  uint32_t result(self->CharCode());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setNumber(result);
  return true;
}

static const JSJitInfo charCode_getterinfo = {
  { (JSJitGetterOp)get_charCode },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_keyCode(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  uint32_t result(self->KeyCode());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setNumber(result);
  return true;
}

static const JSJitInfo keyCode_getterinfo = {
  { (JSJitGetterOp)get_keyCode },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_altKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->AltKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo altKey_getterinfo = {
  { (JSJitGetterOp)get_altKey },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_ctrlKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->CtrlKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo ctrlKey_getterinfo = {
  { (JSJitGetterOp)get_ctrlKey },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_shiftKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->ShiftKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo shiftKey_getterinfo = {
  { (JSJitGetterOp)get_shiftKey },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_metaKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->MetaKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo metaKey_getterinfo = {
  { (JSJitGetterOp)get_metaKey },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getModifierState(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "KeyboardEvent.getModifierState");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  bool result(self->GetModifierState(NonNullHelper(Constify(arg0))));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo getModifierState_methodinfo = {
  { (JSJitGetterOp)getModifierState },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_location(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  uint32_t result(self->Location());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setNumber(result);
  return true;
}

static const JSJitInfo location_getterinfo = {
  { (JSJitGetterOp)get_location },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_repeat(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->Repeat());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo repeat_getterinfo = {
  { (JSJitGetterOp)get_repeat },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_isComposing(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->IsComposing());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isComposing_getterinfo = {
  { (JSJitGetterOp)get_isComposing },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_key(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetKey(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo key_getterinfo = {
  { (JSJitGetterOp)get_key },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_code(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetCode(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo code_getterinfo = {
  { (JSJitGetterOp)get_code },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
initKeyEvent(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 10)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "KeyboardEvent.initKeyEvent");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  bool arg1;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  bool arg2;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  nsGlobalWindow* arg3;
  if (args[3].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::Window, nsGlobalWindow>(&args[3].toObject(), arg3);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 4 of KeyboardEvent.initKeyEvent", "Window");
        return false;
      }
    }
  } else if (args[3].isNullOrUndefined()) {
    arg3 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 4 of KeyboardEvent.initKeyEvent");
    return false;
  }
  bool arg4;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  bool arg5;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  bool arg6;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[6], &arg6)) {
    return false;
  }
  bool arg7;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[7], &arg7)) {
    return false;
  }
  uint32_t arg8;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[8], &arg8)) {
    return false;
  }
  uint32_t arg9;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[9], &arg9)) {
    return false;
  }
  ErrorResult rv;
  self->InitKeyEvent(NonNullHelper(Constify(arg0)), arg1, arg2, Constify(arg3), arg4, arg5, arg6, arg7, arg8, arg9, rv);
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailedWithDetails(cx, rv, "KeyboardEvent", "initKeyEvent");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo initKeyEvent_methodinfo = {
  { (JSJitGetterOp)initKeyEvent },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_isTrusted(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->IsTrusted());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isTrusted_getterinfo = {
  { (JSJitGetterOp)get_isTrusted },
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasDOMSets, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  true,  /* isMovable.  Not relevant for setters. */
  true, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::KeyboardEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::KeyboardEvent>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::KeyboardEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::KeyboardEvent>(obj);
  if (self) {
    JSBindingFinalized<mozilla::dom::KeyboardEvent>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::KeyboardEvent>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::KeyboardEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::KeyboardEvent>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("getModifierState", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getModifierState_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("initKeyEvent", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&initKeyEvent_methodinfo), 10, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, nullptr }
};

static jsid sMethods_ids[3];

static const JSPropertySpec sAttributes_specs[] = {
  { "charCode", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &charCode_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "keyCode", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &keyCode_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "altKey", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &altKey_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "ctrlKey", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &ctrlKey_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "shiftKey", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &shiftKey_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "metaKey", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &metaKey_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "location", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &location_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "repeat", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &repeat_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "isComposing", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &isComposing_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "key", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &key_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END,
  { "code", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &code_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { true, nullptr, nullptr, nullptr, &sAttributes_specs[11] },
  { false, nullptr }
};

static jsid sAttributes_ids[13];

static const JSPropertySpec sUnforgeableAttributes_specs[] = {
  { "isTrusted", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_PERMANENT, { { GenericBindingGetter, &isTrusted_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sUnforgeableAttributes[] = {
  { true, nullptr, nullptr, nullptr, &sUnforgeableAttributes_specs[0] },
  { false, nullptr }
};

static jsid sUnforgeableAttributes_ids[2];

static const ConstantSpec sConstants_specs[] = {
  { "DOM_KEY_LOCATION_STANDARD", UINT_TO_JSVAL(0U) },
  { "DOM_KEY_LOCATION_LEFT", UINT_TO_JSVAL(1U) },
  { "DOM_KEY_LOCATION_RIGHT", UINT_TO_JSVAL(2U) },
  { "DOM_KEY_LOCATION_NUMPAD", UINT_TO_JSVAL(3U) },
  { "DOM_VK_CANCEL", UINT_TO_JSVAL(3U) },
  { "DOM_VK_HELP", UINT_TO_JSVAL(6U) },
  { "DOM_VK_BACK_SPACE", UINT_TO_JSVAL(8U) },
  { "DOM_VK_TAB", UINT_TO_JSVAL(9U) },
  { "DOM_VK_CLEAR", UINT_TO_JSVAL(12U) },
  { "DOM_VK_RETURN", UINT_TO_JSVAL(13U) },
  { "DOM_VK_SHIFT", UINT_TO_JSVAL(16U) },
  { "DOM_VK_CONTROL", UINT_TO_JSVAL(17U) },
  { "DOM_VK_ALT", UINT_TO_JSVAL(18U) },
  { "DOM_VK_PAUSE", UINT_TO_JSVAL(19U) },
  { "DOM_VK_CAPS_LOCK", UINT_TO_JSVAL(20U) },
  { "DOM_VK_KANA", UINT_TO_JSVAL(21U) },
  { "DOM_VK_HANGUL", UINT_TO_JSVAL(21U) },
  { "DOM_VK_EISU", UINT_TO_JSVAL(22U) },
  { "DOM_VK_JUNJA", UINT_TO_JSVAL(23U) },
  { "DOM_VK_FINAL", UINT_TO_JSVAL(24U) },
  { "DOM_VK_HANJA", UINT_TO_JSVAL(25U) },
  { "DOM_VK_KANJI", UINT_TO_JSVAL(25U) },
  { "DOM_VK_ESCAPE", UINT_TO_JSVAL(27U) },
  { "DOM_VK_CONVERT", UINT_TO_JSVAL(28U) },
  { "DOM_VK_NONCONVERT", UINT_TO_JSVAL(29U) },
  { "DOM_VK_ACCEPT", UINT_TO_JSVAL(30U) },
  { "DOM_VK_MODECHANGE", UINT_TO_JSVAL(31U) },
  { "DOM_VK_SPACE", UINT_TO_JSVAL(32U) },
  { "DOM_VK_PAGE_UP", UINT_TO_JSVAL(33U) },
  { "DOM_VK_PAGE_DOWN", UINT_TO_JSVAL(34U) },
  { "DOM_VK_END", UINT_TO_JSVAL(35U) },
  { "DOM_VK_HOME", UINT_TO_JSVAL(36U) },
  { "DOM_VK_LEFT", UINT_TO_JSVAL(37U) },
  { "DOM_VK_UP", UINT_TO_JSVAL(38U) },
  { "DOM_VK_RIGHT", UINT_TO_JSVAL(39U) },
  { "DOM_VK_DOWN", UINT_TO_JSVAL(40U) },
  { "DOM_VK_SELECT", UINT_TO_JSVAL(41U) },
  { "DOM_VK_PRINT", UINT_TO_JSVAL(42U) },
  { "DOM_VK_EXECUTE", UINT_TO_JSVAL(43U) },
  { "DOM_VK_PRINTSCREEN", UINT_TO_JSVAL(44U) },
  { "DOM_VK_INSERT", UINT_TO_JSVAL(45U) },
  { "DOM_VK_DELETE", UINT_TO_JSVAL(46U) },
  { "DOM_VK_0", UINT_TO_JSVAL(48U) },
  { "DOM_VK_1", UINT_TO_JSVAL(49U) },
  { "DOM_VK_2", UINT_TO_JSVAL(50U) },
  { "DOM_VK_3", UINT_TO_JSVAL(51U) },
  { "DOM_VK_4", UINT_TO_JSVAL(52U) },
  { "DOM_VK_5", UINT_TO_JSVAL(53U) },
  { "DOM_VK_6", UINT_TO_JSVAL(54U) },
  { "DOM_VK_7", UINT_TO_JSVAL(55U) },
  { "DOM_VK_8", UINT_TO_JSVAL(56U) },
  { "DOM_VK_9", UINT_TO_JSVAL(57U) },
  { "DOM_VK_COLON", UINT_TO_JSVAL(58U) },
  { "DOM_VK_SEMICOLON", UINT_TO_JSVAL(59U) },
  { "DOM_VK_LESS_THAN", UINT_TO_JSVAL(60U) },
  { "DOM_VK_EQUALS", UINT_TO_JSVAL(61U) },
  { "DOM_VK_GREATER_THAN", UINT_TO_JSVAL(62U) },
  { "DOM_VK_QUESTION_MARK", UINT_TO_JSVAL(63U) },
  { "DOM_VK_AT", UINT_TO_JSVAL(64U) },
  { "DOM_VK_A", UINT_TO_JSVAL(65U) },
  { "DOM_VK_B", UINT_TO_JSVAL(66U) },
  { "DOM_VK_C", UINT_TO_JSVAL(67U) },
  { "DOM_VK_D", UINT_TO_JSVAL(68U) },
  { "DOM_VK_E", UINT_TO_JSVAL(69U) },
  { "DOM_VK_F", UINT_TO_JSVAL(70U) },
  { "DOM_VK_G", UINT_TO_JSVAL(71U) },
  { "DOM_VK_H", UINT_TO_JSVAL(72U) },
  { "DOM_VK_I", UINT_TO_JSVAL(73U) },
  { "DOM_VK_J", UINT_TO_JSVAL(74U) },
  { "DOM_VK_K", UINT_TO_JSVAL(75U) },
  { "DOM_VK_L", UINT_TO_JSVAL(76U) },
  { "DOM_VK_M", UINT_TO_JSVAL(77U) },
  { "DOM_VK_N", UINT_TO_JSVAL(78U) },
  { "DOM_VK_O", UINT_TO_JSVAL(79U) },
  { "DOM_VK_P", UINT_TO_JSVAL(80U) },
  { "DOM_VK_Q", UINT_TO_JSVAL(81U) },
  { "DOM_VK_R", UINT_TO_JSVAL(82U) },
  { "DOM_VK_S", UINT_TO_JSVAL(83U) },
  { "DOM_VK_T", UINT_TO_JSVAL(84U) },
  { "DOM_VK_U", UINT_TO_JSVAL(85U) },
  { "DOM_VK_V", UINT_TO_JSVAL(86U) },
  { "DOM_VK_W", UINT_TO_JSVAL(87U) },
  { "DOM_VK_X", UINT_TO_JSVAL(88U) },
  { "DOM_VK_Y", UINT_TO_JSVAL(89U) },
  { "DOM_VK_Z", UINT_TO_JSVAL(90U) },
  { "DOM_VK_WIN", UINT_TO_JSVAL(91U) },
  { "DOM_VK_CONTEXT_MENU", UINT_TO_JSVAL(93U) },
  { "DOM_VK_SLEEP", UINT_TO_JSVAL(95U) },
  { "DOM_VK_NUMPAD0", UINT_TO_JSVAL(96U) },
  { "DOM_VK_NUMPAD1", UINT_TO_JSVAL(97U) },
  { "DOM_VK_NUMPAD2", UINT_TO_JSVAL(98U) },
  { "DOM_VK_NUMPAD3", UINT_TO_JSVAL(99U) },
  { "DOM_VK_NUMPAD4", UINT_TO_JSVAL(100U) },
  { "DOM_VK_NUMPAD5", UINT_TO_JSVAL(101U) },
  { "DOM_VK_NUMPAD6", UINT_TO_JSVAL(102U) },
  { "DOM_VK_NUMPAD7", UINT_TO_JSVAL(103U) },
  { "DOM_VK_NUMPAD8", UINT_TO_JSVAL(104U) },
  { "DOM_VK_NUMPAD9", UINT_TO_JSVAL(105U) },
  { "DOM_VK_MULTIPLY", UINT_TO_JSVAL(106U) },
  { "DOM_VK_ADD", UINT_TO_JSVAL(107U) },
  { "DOM_VK_SEPARATOR", UINT_TO_JSVAL(108U) },
  { "DOM_VK_SUBTRACT", UINT_TO_JSVAL(109U) },
  { "DOM_VK_DECIMAL", UINT_TO_JSVAL(110U) },
  { "DOM_VK_DIVIDE", UINT_TO_JSVAL(111U) },
  { "DOM_VK_F1", UINT_TO_JSVAL(112U) },
  { "DOM_VK_F2", UINT_TO_JSVAL(113U) },
  { "DOM_VK_F3", UINT_TO_JSVAL(114U) },
  { "DOM_VK_F4", UINT_TO_JSVAL(115U) },
  { "DOM_VK_F5", UINT_TO_JSVAL(116U) },
  { "DOM_VK_F6", UINT_TO_JSVAL(117U) },
  { "DOM_VK_F7", UINT_TO_JSVAL(118U) },
  { "DOM_VK_F8", UINT_TO_JSVAL(119U) },
  { "DOM_VK_F9", UINT_TO_JSVAL(120U) },
  { "DOM_VK_F10", UINT_TO_JSVAL(121U) },
  { "DOM_VK_F11", UINT_TO_JSVAL(122U) },
  { "DOM_VK_F12", UINT_TO_JSVAL(123U) },
  { "DOM_VK_F13", UINT_TO_JSVAL(124U) },
  { "DOM_VK_F14", UINT_TO_JSVAL(125U) },
  { "DOM_VK_F15", UINT_TO_JSVAL(126U) },
  { "DOM_VK_F16", UINT_TO_JSVAL(127U) },
  { "DOM_VK_F17", UINT_TO_JSVAL(128U) },
  { "DOM_VK_F18", UINT_TO_JSVAL(129U) },
  { "DOM_VK_F19", UINT_TO_JSVAL(130U) },
  { "DOM_VK_F20", UINT_TO_JSVAL(131U) },
  { "DOM_VK_F21", UINT_TO_JSVAL(132U) },
  { "DOM_VK_F22", UINT_TO_JSVAL(133U) },
  { "DOM_VK_F23", UINT_TO_JSVAL(134U) },
  { "DOM_VK_F24", UINT_TO_JSVAL(135U) },
  { "DOM_VK_NUM_LOCK", UINT_TO_JSVAL(144U) },
  { "DOM_VK_SCROLL_LOCK", UINT_TO_JSVAL(145U) },
  { "DOM_VK_WIN_OEM_FJ_JISHO", UINT_TO_JSVAL(146U) },
  { "DOM_VK_WIN_OEM_FJ_MASSHOU", UINT_TO_JSVAL(147U) },
  { "DOM_VK_WIN_OEM_FJ_TOUROKU", UINT_TO_JSVAL(148U) },
  { "DOM_VK_WIN_OEM_FJ_LOYA", UINT_TO_JSVAL(149U) },
  { "DOM_VK_WIN_OEM_FJ_ROYA", UINT_TO_JSVAL(150U) },
  { "DOM_VK_CIRCUMFLEX", UINT_TO_JSVAL(160U) },
  { "DOM_VK_EXCLAMATION", UINT_TO_JSVAL(161U) },
  { "DOM_VK_DOUBLE_QUOTE", UINT_TO_JSVAL(162U) },
  { "DOM_VK_HASH", UINT_TO_JSVAL(163U) },
  { "DOM_VK_DOLLAR", UINT_TO_JSVAL(164U) },
  { "DOM_VK_PERCENT", UINT_TO_JSVAL(165U) },
  { "DOM_VK_AMPERSAND", UINT_TO_JSVAL(166U) },
  { "DOM_VK_UNDERSCORE", UINT_TO_JSVAL(167U) },
  { "DOM_VK_OPEN_PAREN", UINT_TO_JSVAL(168U) },
  { "DOM_VK_CLOSE_PAREN", UINT_TO_JSVAL(169U) },
  { "DOM_VK_ASTERISK", UINT_TO_JSVAL(170U) },
  { "DOM_VK_PLUS", UINT_TO_JSVAL(171U) },
  { "DOM_VK_PIPE", UINT_TO_JSVAL(172U) },
  { "DOM_VK_HYPHEN_MINUS", UINT_TO_JSVAL(173U) },
  { "DOM_VK_OPEN_CURLY_BRACKET", UINT_TO_JSVAL(174U) },
  { "DOM_VK_CLOSE_CURLY_BRACKET", UINT_TO_JSVAL(175U) },
  { "DOM_VK_TILDE", UINT_TO_JSVAL(176U) },
  { "DOM_VK_VOLUME_MUTE", UINT_TO_JSVAL(181U) },
  { "DOM_VK_VOLUME_DOWN", UINT_TO_JSVAL(182U) },
  { "DOM_VK_VOLUME_UP", UINT_TO_JSVAL(183U) },
  { "DOM_VK_COMMA", UINT_TO_JSVAL(188U) },
  { "DOM_VK_PERIOD", UINT_TO_JSVAL(190U) },
  { "DOM_VK_SLASH", UINT_TO_JSVAL(191U) },
  { "DOM_VK_BACK_QUOTE", UINT_TO_JSVAL(192U) },
  { "DOM_VK_OPEN_BRACKET", UINT_TO_JSVAL(219U) },
  { "DOM_VK_BACK_SLASH", UINT_TO_JSVAL(220U) },
  { "DOM_VK_CLOSE_BRACKET", UINT_TO_JSVAL(221U) },
  { "DOM_VK_QUOTE", UINT_TO_JSVAL(222U) },
  { "DOM_VK_META", UINT_TO_JSVAL(224U) },
  { "DOM_VK_ALTGR", UINT_TO_JSVAL(225U) },
  { "DOM_VK_WIN_ICO_HELP", UINT_TO_JSVAL(227U) },
  { "DOM_VK_WIN_ICO_00", UINT_TO_JSVAL(228U) },
  { "DOM_VK_WIN_ICO_CLEAR", UINT_TO_JSVAL(230U) },
  { "DOM_VK_WIN_OEM_RESET", UINT_TO_JSVAL(233U) },
  { "DOM_VK_WIN_OEM_JUMP", UINT_TO_JSVAL(234U) },
  { "DOM_VK_WIN_OEM_PA1", UINT_TO_JSVAL(235U) },
  { "DOM_VK_WIN_OEM_PA2", UINT_TO_JSVAL(236U) },
  { "DOM_VK_WIN_OEM_PA3", UINT_TO_JSVAL(237U) },
  { "DOM_VK_WIN_OEM_WSCTRL", UINT_TO_JSVAL(238U) },
  { "DOM_VK_WIN_OEM_CUSEL", UINT_TO_JSVAL(239U) },
  { "DOM_VK_WIN_OEM_ATTN", UINT_TO_JSVAL(240U) },
  { "DOM_VK_WIN_OEM_FINISH", UINT_TO_JSVAL(241U) },
  { "DOM_VK_WIN_OEM_COPY", UINT_TO_JSVAL(242U) },
  { "DOM_VK_WIN_OEM_AUTO", UINT_TO_JSVAL(243U) },
  { "DOM_VK_WIN_OEM_ENLW", UINT_TO_JSVAL(244U) },
  { "DOM_VK_WIN_OEM_BACKTAB", UINT_TO_JSVAL(245U) },
  { "DOM_VK_ATTN", UINT_TO_JSVAL(246U) },
  { "DOM_VK_CRSEL", UINT_TO_JSVAL(247U) },
  { "DOM_VK_EXSEL", UINT_TO_JSVAL(248U) },
  { "DOM_VK_EREOF", UINT_TO_JSVAL(249U) },
  { "DOM_VK_PLAY", UINT_TO_JSVAL(250U) },
  { "DOM_VK_ZOOM", UINT_TO_JSVAL(251U) },
  { "DOM_VK_PA1", UINT_TO_JSVAL(253U) },
  { "DOM_VK_WIN_OEM_CLEAR", UINT_TO_JSVAL(254U) },
  { 0, JS::UndefinedValue() }
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const ConstantSpec> sConstants[] = {
  { true, nullptr, nullptr, nullptr, &sConstants_specs[0] },
  { false, nullptr }
};

static jsid sConstants_ids[190];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  sUnforgeableAttributes, sUnforgeableAttributes_ids, sUnforgeableAttributes_specs,
  sConstants, sConstants_ids, sConstants_specs,
  -1
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, nullptr },
  prototypes::id::KeyboardEvent,
  constructors::id::KeyboardEvent,
  UIEventBinding::sNativePropertyHooks
} };

static bool
_constructor(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JS::CallArgs args = JS::CallArgsFromVp(argc, vp);
  JS::Rooted<JSObject*> obj(cx, &args.callee());
  bool mayInvoke = args.isConstructing();
#ifdef RELEASE_BUILD
  mayInvoke = mayInvoke || nsContentUtils::ThreadsafeIsCallerChrome();
#endif // RELEASE_BUILD
  if (!mayInvoke) {
    // XXXbz wish I could get the name from the callee instead of
    // Adding more relocations
    return ThrowConstructorWithoutNew(cx, "KeyboardEvent");
  }

  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "KeyboardEvent");
  }
  GlobalObject global(cx, obj);
  if (global.Failed()) {
    return false;
  }

  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  binding_detail::FastKeyboardEventInit arg1;
  if (!arg1.Init(cx, (args.hasDefined(1)) ? args[1] : JS::NullHandleValue, "Argument 2 of KeyboardEvent.constructor", false)) {
    return false;
  }
  Maybe<JSAutoCompartment> ac;
  if (objIsXray) {
    obj = js::CheckedUnwrap(obj);
    if (!obj) {
      return false;
    }
    ac.emplace(cx, obj);
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::KeyboardEvent>(mozilla::dom::KeyboardEvent::Constructor(global, NonNullHelper(Constify(arg0)), Constify(arg1), rv)));
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailedWithDetails(cx, rv, "KeyboardEvent", "constructor");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    _constructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    _constructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function KeyboardEvent() {\n    [native code]\n}",
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  UIEventBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "KeyboardEventPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE + 1 /* slot for the JSObject holding the unforgeable properties */),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object KeyboardEventPrototype]",
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  UIEventBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

static const DOMJSClass Class = {
  { "KeyboardEvent",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::Event, prototypes::id::UIEvent, prototypes::id::KeyboardEvent, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::KeyboardEvent >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::KeyboardEvent>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::KeyboardEvent>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::KeyboardEvent* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::KeyboardEvent*>(aObject) ==
             reinterpret_cast<mozilla::dom::KeyboardEvent*>(aObject),
             "Multiple inheritance for mozilla::dom::KeyboardEvent is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::UIEvent*>(aObject) ==
             reinterpret_cast<mozilla::dom::UIEvent*>(aObject),
             "Multiple inheritance for mozilla::dom::UIEvent is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::Event*>(aObject) ==
             reinterpret_cast<mozilla::dom::Event*>(aObject),
             "Multiple inheritance for mozilla::dom::Event is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
    MOZ_ASSERT(!aGivenProto,
               "How are we supposed to change the proto now?");
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::KeyboardEvent> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);

  // Important: do unforgeable property setup after we have handed
  // over ownership of the C++ object to obj as needed, so that if
  // we fail and it ends up GCed it won't have problems in the
  // finalizer trying to drop its ownership of the C++ object.
  JS::Rooted<JSObject*> unforgeableHolder(aCx,
    &js::GetReservedSlot(canonicalProto, DOM_INTERFACE_PROTO_SLOTS_BASE).toObject());
  if (!JS_InitializePropertiesFromCompatibleNativeObject(aCx, aReflector, unforgeableHolder)) {
    aCache->ReleaseWrapper(aObject);
    aCache->ClearWrapper();
    return false;
  }
  creator.InitializationSucceeded();
  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(UIEventBinding::GetProtoObjectHandle(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(UIEventBinding::GetConstructorObjectHandle(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    if (!InitIds(aCx, sUnforgeableAttributes, sUnforgeableAttributes_ids)) {
      return;
    }
    if (!InitIds(aCx, sConstants, sConstants_ids)) {
      return;
    }
    sIdsInited = true;
  }

  static bool sPrefCachesInited = false;
  if (!sPrefCachesInited) {
    sPrefCachesInited = true;
    Preferences::AddBoolVarCache(&sAttributes[1].enabled, "dom.keyboardevent.code.enabled");
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::KeyboardEvent);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::KeyboardEvent);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 1, nullptr,
                              interfaceCache,
                              &sNativeProperties,
                              nullptr,
                              "KeyboardEvent", aDefineOnGlobal);

  JS::Rooted<JSObject*> unforgeableHolder(aCx);
  {
    JS::Rooted<JSObject*> holderProto(aCx, *protoCache);
    unforgeableHolder = JS_NewObjectWithoutMetadata(aCx, Class.ToJSClass(), holderProto);
    if (!unforgeableHolder) {
      *protoCache = nullptr;
      if (interfaceCache) {
        *interfaceCache = nullptr;
      }
      return;
    }
  }

  if (!DefineUnforgeableAttributes(aCx, unforgeableHolder, sUnforgeableAttributes)) {
    *protoCache = nullptr;
    if (interfaceCache) {
      *interfaceCache = nullptr;
    }
    return;
  }

  if (*protoCache) {
    js::SetReservedSlot(*protoCache, DOM_INTERFACE_PROTO_SLOTS_BASE,
                        JS::ObjectValue(*unforgeableHolder));
  }
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::KeyboardEvent)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::KeyboardEvent).address());
}

JSObject*
GetProtoObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetProtoObjectHandle(aCx, aGlobal);
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::KeyboardEvent)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::KeyboardEvent).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace KeyboardEventBinding



} // namespace dom
} // namespace mozilla
