/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "WebGL2Context.h"
#include "WebGL2RenderingContextBinding.h"
#include "WebGLActiveInfo.h"
#include "WebGLBuffer.h"
#include "WebGLProgram.h"
#include "WebGLQuery.h"
#include "WebGLRenderingContextBinding.h"
#include "WebGLSampler.h"
#include "WebGLSync.h"
#include "WebGLTransformFeedback.h"
#include "WebGLUniformLocation.h"
#include "WrapperFactory.h"
#include "jsfriendapi.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/HTMLCanvasElement.h"
#include "mozilla/dom/HTMLImageElement.h"
#include "mozilla/dom/HTMLVideoElement.h"
#include "mozilla/dom/ImageData.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/OwningNonNull.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/TypedArray.h"
#include "mozilla/dom/UnionConversions.h"

namespace mozilla {
namespace dom {

void
ImplCycleCollectionTraverse(nsCycleCollectionTraversalCallback& aCallback, OwningWebGLBufferOrLongLong& aUnion, const char* aName, uint32_t aFlags)
{
  if (aUnion.IsWebGLBuffer()) {
    ImplCycleCollectionTraverse(aCallback, aUnion.GetAsWebGLBuffer(), "mWebGLBuffer", aFlags);
  }
}


void
ImplCycleCollectionUnlink(OwningWebGLBufferOrLongLong& aUnion)
{
  aUnion.Uninit();
}


bool
UnsignedLongOrUint32ArrayOrBoolean::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eUnsignedLong: {
      rval.setNumber(mValue.mUnsignedLong.Value());
      return true;
      break;
    }
    case eUint32Array: {
      rval.setObject(*mValue.mUint32Array.Value().Obj());
      if (!MaybeWrapNonDOMObjectValue(cx, rval)) {
        return false;
      }
      return true;
      break;
    }
    case eBoolean: {
      rval.setBoolean(mValue.mBoolean.Value());
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}


uint32_t&
OwningUnsignedLongOrUint32ArrayOrBoolean::RawSetAsUnsignedLong()
{
  if (mType == eUnsignedLong) {
    return mValue.mUnsignedLong.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eUnsignedLong;
  return mValue.mUnsignedLong.SetValue();
}

uint32_t&
OwningUnsignedLongOrUint32ArrayOrBoolean::SetAsUnsignedLong()
{
  if (mType == eUnsignedLong) {
    return mValue.mUnsignedLong.Value();
  }
  Uninit();
  mType = eUnsignedLong;
  return mValue.mUnsignedLong.SetValue();
}

bool
OwningUnsignedLongOrUint32ArrayOrBoolean::TrySetToUnsignedLong(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    uint32_t& memberSlot = RawSetAsUnsignedLong();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, value, &memberSlot)) {
      return false;
    }
  }
  return true;
}

void
OwningUnsignedLongOrUint32ArrayOrBoolean::DestroyUnsignedLong()
{
  MOZ_ASSERT(IsUnsignedLong(), "Wrong type!");
  mValue.mUnsignedLong.Destroy();
  mType = eUninitialized;
}




Uint32Array&
OwningUnsignedLongOrUint32ArrayOrBoolean::RawSetAsUint32Array()
{
  if (mType == eUint32Array) {
    return mValue.mUint32Array.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eUint32Array;
  return mValue.mUint32Array.SetValue();
}

Uint32Array&
OwningUnsignedLongOrUint32ArrayOrBoolean::SetAsUint32Array()
{
  if (mType == eUint32Array) {
    return mValue.mUint32Array.Value();
  }
  Uninit();
  mType = eUint32Array;
  return mValue.mUint32Array.SetValue();
}

bool
OwningUnsignedLongOrUint32ArrayOrBoolean::TrySetToUint32Array(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    Uint32Array& memberSlot = RawSetAsUint32Array();
    if (!memberSlot.Init(&value.toObject())) {
      DestroyUint32Array();
      tryNext = true;
      return true;
    }
  }
  return true;
}

void
OwningUnsignedLongOrUint32ArrayOrBoolean::DestroyUint32Array()
{
  MOZ_ASSERT(IsUint32Array(), "Wrong type!");
  mValue.mUint32Array.Destroy();
  mType = eUninitialized;
}




bool&
OwningUnsignedLongOrUint32ArrayOrBoolean::RawSetAsBoolean()
{
  if (mType == eBoolean) {
    return mValue.mBoolean.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eBoolean;
  return mValue.mBoolean.SetValue();
}

bool&
OwningUnsignedLongOrUint32ArrayOrBoolean::SetAsBoolean()
{
  if (mType == eBoolean) {
    return mValue.mBoolean.Value();
  }
  Uninit();
  mType = eBoolean;
  return mValue.mBoolean.SetValue();
}

bool
OwningUnsignedLongOrUint32ArrayOrBoolean::TrySetToBoolean(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    bool& memberSlot = RawSetAsBoolean();
    if (!ValueToPrimitive<bool, eDefault>(cx, value, &memberSlot)) {
      return false;
    }
  }
  return true;
}

void
OwningUnsignedLongOrUint32ArrayOrBoolean::DestroyBoolean()
{
  MOZ_ASSERT(IsBoolean(), "Wrong type!");
  mValue.mBoolean.Destroy();
  mType = eUninitialized;
}




void
OwningUnsignedLongOrUint32ArrayOrBoolean::Uninit()
{
  switch (mType) {
    case eUninitialized: {
      break;
    }
    case eUnsignedLong: {
      DestroyUnsignedLong();
      break;
    }
    case eUint32Array: {
      DestroyUint32Array();
      break;
    }
    case eBoolean: {
      DestroyBoolean();
      break;
    }
  }
}

bool
OwningUnsignedLongOrUint32ArrayOrBoolean::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eUnsignedLong: {
      rval.setNumber(mValue.mUnsignedLong.Value());
      return true;
      break;
    }
    case eUint32Array: {
      rval.setObject(*mValue.mUint32Array.Value().Obj());
      if (!MaybeWrapNonDOMObjectValue(cx, rval)) {
        return false;
      }
      return true;
      break;
    }
    case eBoolean: {
      rval.setBoolean(mValue.mBoolean.Value());
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}

void
OwningUnsignedLongOrUint32ArrayOrBoolean::TraceUnion(JSTracer* trc)
{
  switch (mType) {
    case eUint32Array: {
      mValue.mUint32Array.Value().TraceSelf(trc);
      break;
    }
    default: {
      break;
    }
  }
}


bool
WebGLBufferOrLongLong::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eWebGLBuffer: {
      if (!GetOrCreateDOMReflector(cx, scopeObj, mValue.mWebGLBuffer.Value(), rval)) {
        MOZ_ASSERT(true || JS_IsExceptionPending(cx));
        return false;
      }
      return true;
      break;
    }
    case eLongLong: {
      rval.set(JS_NumberValue(double(mValue.mLongLong.Value())));
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}


OwningNonNull<mozilla::WebGLBuffer>&
OwningWebGLBufferOrLongLong::RawSetAsWebGLBuffer()
{
  if (mType == eWebGLBuffer) {
    return mValue.mWebGLBuffer.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eWebGLBuffer;
  return mValue.mWebGLBuffer.SetValue();
}

OwningNonNull<mozilla::WebGLBuffer>&
OwningWebGLBufferOrLongLong::SetAsWebGLBuffer()
{
  if (mType == eWebGLBuffer) {
    return mValue.mWebGLBuffer.Value();
  }
  Uninit();
  mType = eWebGLBuffer;
  return mValue.mWebGLBuffer.SetValue();
}

bool
OwningWebGLBufferOrLongLong::TrySetToWebGLBuffer(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    OwningNonNull<mozilla::WebGLBuffer>& memberSlot = RawSetAsWebGLBuffer();
    static_assert(IsRefcounted<mozilla::WebGLBuffer>::value, "We can only store refcounted classes.");{
      nsresult rv = UnwrapObject<prototypes::id::WebGLBuffer, mozilla::WebGLBuffer>(&value.toObject(), memberSlot);
      if (NS_FAILED(rv)) {
        DestroyWebGLBuffer();
        tryNext = true;
        return true;
      }
    }
  }
  return true;
}

void
OwningWebGLBufferOrLongLong::DestroyWebGLBuffer()
{
  MOZ_ASSERT(IsWebGLBuffer(), "Wrong type!");
  mValue.mWebGLBuffer.Destroy();
  mType = eUninitialized;
}




int64_t&
OwningWebGLBufferOrLongLong::RawSetAsLongLong()
{
  if (mType == eLongLong) {
    return mValue.mLongLong.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eLongLong;
  return mValue.mLongLong.SetValue();
}

int64_t&
OwningWebGLBufferOrLongLong::SetAsLongLong()
{
  if (mType == eLongLong) {
    return mValue.mLongLong.Value();
  }
  Uninit();
  mType = eLongLong;
  return mValue.mLongLong.SetValue();
}

bool
OwningWebGLBufferOrLongLong::TrySetToLongLong(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    int64_t& memberSlot = RawSetAsLongLong();
    if (!ValueToPrimitive<int64_t, eDefault>(cx, value, &memberSlot)) {
      return false;
    }
  }
  return true;
}

void
OwningWebGLBufferOrLongLong::DestroyLongLong()
{
  MOZ_ASSERT(IsLongLong(), "Wrong type!");
  mValue.mLongLong.Destroy();
  mType = eUninitialized;
}




void
OwningWebGLBufferOrLongLong::Uninit()
{
  switch (mType) {
    case eUninitialized: {
      break;
    }
    case eWebGLBuffer: {
      DestroyWebGLBuffer();
      break;
    }
    case eLongLong: {
      DestroyLongLong();
      break;
    }
  }
}

bool
OwningWebGLBufferOrLongLong::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eWebGLBuffer: {
      if (!GetOrCreateDOMReflector(cx, scopeObj, mValue.mWebGLBuffer.Value(), rval)) {
        MOZ_ASSERT(true || JS_IsExceptionPending(cx));
        return false;
      }
      return true;
      break;
    }
    case eLongLong: {
      rval.set(JS_NumberValue(double(mValue.mLongLong.Value())));
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}

void
OwningWebGLBufferOrLongLong::TraceUnion(JSTracer* trc)
{
}

void
OwningWebGLBufferOrLongLong::operator=(const OwningWebGLBufferOrLongLong& aOther)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eWebGLBuffer: {
      SetAsWebGLBuffer() = aOther.GetAsWebGLBuffer();
      break;
    }
    case eLongLong: {
      SetAsLongLong() = aOther.GetAsLongLong();
      break;
    }
  }
}


namespace WebGL2RenderingContextBinding {

static_assert(IsRefcounted<NativeType>::value == IsRefcounted<WebGLRenderingContextBinding::NativeType>::value,
              "Can't inherit from an interface with a different ownership model.");

static bool
copyBufferSubData(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 5)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.copyBufferSubData");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  int64_t arg2;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int64_t arg3;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int64_t arg4;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  self->CopyBufferSubData(arg0, arg1, arg2, arg3, arg4);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo copyBufferSubData_methodinfo = {
  { (JSJitGetterOp)copyBufferSubData },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getBufferSubData(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getBufferSubData");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int64_t arg1;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  RootedTypedArray<Nullable<ArrayBuffer>> arg2(cx);
  if (args[2].isObject()) {
    if (!arg2.SetValue().Init(&args[2].toObject())) {
      ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 3 of WebGL2RenderingContext.getBufferSubData", "ArrayBufferOrNull");
      return false;
    }
  } else if (args[2].isNullOrUndefined()) {
    arg2.SetNull();
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 3 of WebGL2RenderingContext.getBufferSubData");
    return false;
  }
  self->GetBufferSubData(arg0, arg1, Constify(arg2));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo getBufferSubData_methodinfo = {
  { (JSJitGetterOp)getBufferSubData },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
blitFramebuffer(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 10)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.blitFramebuffer");
  }
  int32_t arg0;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  int32_t arg2;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  int32_t arg5;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  int32_t arg6;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[6], &arg6)) {
    return false;
  }
  int32_t arg7;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[7], &arg7)) {
    return false;
  }
  uint32_t arg8;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[8], &arg8)) {
    return false;
  }
  uint32_t arg9;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[9], &arg9)) {
    return false;
  }
  self->BlitFramebuffer(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo blitFramebuffer_methodinfo = {
  { (JSJitGetterOp)blitFramebuffer },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
framebufferTextureLayer(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 5)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.framebufferTextureLayer");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  self->FramebufferTextureLayer(arg0, arg1, arg2, arg3, arg4);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo framebufferTextureLayer_methodinfo = {
  { (JSJitGetterOp)framebufferTextureLayer },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getInternalformatParameter(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getInternalformatParameter");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  JS::Rooted<JS::Value> result(cx);
  self->GetInternalformatParameter(cx, arg0, arg1, arg2, &result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  JS::ExposeValueToActiveJS(result);
  args.rval().set(result);
  if (!MaybeWrapValue(cx, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo getInternalformatParameter_methodinfo = {
  { (JSJitGetterOp)getInternalformatParameter },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
invalidateFramebuffer(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.invalidateFramebuffer");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  binding_detail::AutoSequence<uint32_t> arg1;
  if (args[1].isObject()) {
    JS::ForOfIterator iter(cx);
    if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.invalidateFramebuffer");
      return false;
    }
    binding_detail::AutoSequence<uint32_t> &arr = arg1;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      uint32_t* slotPtr = arr.AppendElement();
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      uint32_t& slot = *slotPtr;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
        return false;
      }
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.invalidateFramebuffer");
    return false;
  }
  self->InvalidateFramebuffer(arg0, Constify(arg1));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo invalidateFramebuffer_methodinfo = {
  { (JSJitGetterOp)invalidateFramebuffer },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
invalidateSubFramebuffer(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 6)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.invalidateSubFramebuffer");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  binding_detail::AutoSequence<uint32_t> arg1;
  if (args[1].isObject()) {
    JS::ForOfIterator iter(cx);
    if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.invalidateSubFramebuffer");
      return false;
    }
    binding_detail::AutoSequence<uint32_t> &arr = arg1;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      uint32_t* slotPtr = arr.AppendElement();
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      uint32_t& slot = *slotPtr;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
        return false;
      }
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.invalidateSubFramebuffer");
    return false;
  }
  int32_t arg2;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  int32_t arg5;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  self->InvalidateSubFramebuffer(arg0, Constify(arg1), arg2, arg3, arg4, arg5);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo invalidateSubFramebuffer_methodinfo = {
  { (JSJitGetterOp)invalidateSubFramebuffer },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
readBuffer(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.readBuffer");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  self->ReadBuffer(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo readBuffer_methodinfo = {
  { (JSJitGetterOp)readBuffer },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
renderbufferStorageMultisample(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 5)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.renderbufferStorageMultisample");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  self->RenderbufferStorageMultisample(arg0, arg1, arg2, arg3, arg4);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo renderbufferStorageMultisample_methodinfo = {
  { (JSJitGetterOp)renderbufferStorageMultisample },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
texStorage2D(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 5)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.texStorage2D");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  self->TexStorage2D(arg0, arg1, arg2, arg3, arg4);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo texStorage2D_methodinfo = {
  { (JSJitGetterOp)texStorage2D },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
texStorage3D(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 6)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.texStorage3D");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  int32_t arg5;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  self->TexStorage3D(arg0, arg1, arg2, arg3, arg4, arg5);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo texStorage3D_methodinfo = {
  { (JSJitGetterOp)texStorage3D },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
texImage3D(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 10)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.texImage3D");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  int32_t arg5;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  int32_t arg6;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[6], &arg6)) {
    return false;
  }
  uint32_t arg7;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[7], &arg7)) {
    return false;
  }
  uint32_t arg8;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[8], &arg8)) {
    return false;
  }
  RootedTypedArray<Nullable<ArrayBufferView>> arg9(cx);
  if (args[9].isObject()) {
    if (!arg9.SetValue().Init(&args[9].toObject())) {
      ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 10 of WebGL2RenderingContext.texImage3D", "ArrayBufferViewOrNull");
      return false;
    }
  } else if (args[9].isNullOrUndefined()) {
    arg9.SetNull();
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 10 of WebGL2RenderingContext.texImage3D");
    return false;
  }
  ErrorResult rv;
  self->TexImage3D(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, Constify(arg9), rv);
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailedWithDetails(cx, rv, "WebGL2RenderingContext", "texImage3D");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo texImage3D_methodinfo = {
  { (JSJitGetterOp)texImage3D },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
texSubImage3D(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 11u);
  switch (argcount) {
    case 8: {
      uint32_t arg0;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
        return false;
      }
      int32_t arg1;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      int32_t arg2;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[2], &arg2)) {
        return false;
      }
      int32_t arg3;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
        return false;
      }
      int32_t arg4;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
        return false;
      }
      uint32_t arg5;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[5], &arg5)) {
        return false;
      }
      uint32_t arg6;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[6], &arg6)) {
        return false;
      }
      if (args[7].isNullOrUndefined()) {
        mozilla::dom::ImageData* arg7;
        arg7 = nullptr;
        ErrorResult rv;
        self->TexSubImage3D(arg0, arg1, arg2, arg3, arg4, arg5, arg6, Constify(arg7), rv);
        rv.WouldReportJSException();
        if (MOZ_UNLIKELY(rv.Failed())) {
          return ThrowMethodFailedWithDetails(cx, rv, "WebGL2RenderingContext", "texSubImage3D");
        }
        MOZ_ASSERT(!JS_IsExceptionPending(cx));
        args.rval().setUndefined();
        return true;
      }
      if (args[7].isObject()) {
        do {
          mozilla::dom::ImageData* arg7;
          {
            nsresult rv = UnwrapObject<prototypes::id::ImageData, mozilla::dom::ImageData>(&args[7].toObject(), arg7);
            if (NS_FAILED(rv)) {
              break;
            }
          }
          ErrorResult rv;
          self->TexSubImage3D(arg0, arg1, arg2, arg3, arg4, arg5, arg6, Constify(arg7), rv);
          rv.WouldReportJSException();
          if (MOZ_UNLIKELY(rv.Failed())) {
            return ThrowMethodFailedWithDetails(cx, rv, "WebGL2RenderingContext", "texSubImage3D");
          }
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          NonNull<mozilla::dom::HTMLImageElement> arg7;
          {
            nsresult rv = UnwrapObject<prototypes::id::HTMLImageElement, mozilla::dom::HTMLImageElement>(&args[7].toObject(), arg7);
            if (NS_FAILED(rv)) {
              break;
            }
          }
          ErrorResult rv;
          self->TexSubImage3D(arg0, arg1, arg2, arg3, arg4, arg5, arg6, NonNullHelper(arg7), rv);
          rv.WouldReportJSException();
          if (MOZ_UNLIKELY(rv.Failed())) {
            return ThrowMethodFailedWithDetails(cx, rv, "WebGL2RenderingContext", "texSubImage3D");
          }
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          NonNull<mozilla::dom::HTMLCanvasElement> arg7;
          {
            nsresult rv = UnwrapObject<prototypes::id::HTMLCanvasElement, mozilla::dom::HTMLCanvasElement>(&args[7].toObject(), arg7);
            if (NS_FAILED(rv)) {
              break;
            }
          }
          ErrorResult rv;
          self->TexSubImage3D(arg0, arg1, arg2, arg3, arg4, arg5, arg6, NonNullHelper(arg7), rv);
          rv.WouldReportJSException();
          if (MOZ_UNLIKELY(rv.Failed())) {
            return ThrowMethodFailedWithDetails(cx, rv, "WebGL2RenderingContext", "texSubImage3D");
          }
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          NonNull<mozilla::dom::HTMLVideoElement> arg7;
          {
            nsresult rv = UnwrapObject<prototypes::id::HTMLVideoElement, mozilla::dom::HTMLVideoElement>(&args[7].toObject(), arg7);
            if (NS_FAILED(rv)) {
              break;
            }
          }
          ErrorResult rv;
          self->TexSubImage3D(arg0, arg1, arg2, arg3, arg4, arg5, arg6, NonNullHelper(arg7), rv);
          rv.WouldReportJSException();
          if (MOZ_UNLIKELY(rv.Failed())) {
            return ThrowMethodFailedWithDetails(cx, rv, "WebGL2RenderingContext", "texSubImage3D");
          }
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "8", "8", "WebGL2RenderingContext.texSubImage3D");
      break;
    }
    case 11: {
      uint32_t arg0;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
        return false;
      }
      int32_t arg1;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      int32_t arg2;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[2], &arg2)) {
        return false;
      }
      int32_t arg3;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
        return false;
      }
      int32_t arg4;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
        return false;
      }
      int32_t arg5;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[5], &arg5)) {
        return false;
      }
      int32_t arg6;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[6], &arg6)) {
        return false;
      }
      int32_t arg7;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[7], &arg7)) {
        return false;
      }
      uint32_t arg8;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[8], &arg8)) {
        return false;
      }
      uint32_t arg9;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[9], &arg9)) {
        return false;
      }
      RootedTypedArray<Nullable<ArrayBufferView>> arg10(cx);
      if (args[10].isObject()) {
        if (!arg10.SetValue().Init(&args[10].toObject())) {
          ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 11 of WebGL2RenderingContext.texSubImage3D", "ArrayBufferViewOrNull");
          return false;
        }
      } else if (args[10].isNullOrUndefined()) {
        arg10.SetNull();
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 11 of WebGL2RenderingContext.texSubImage3D");
        return false;
      }
      ErrorResult rv;
      self->TexSubImage3D(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, Constify(arg10), rv);
      rv.WouldReportJSException();
      if (MOZ_UNLIKELY(rv.Failed())) {
        return ThrowMethodFailedWithDetails(cx, rv, "WebGL2RenderingContext", "texSubImage3D");
      }
      MOZ_ASSERT(!JS_IsExceptionPending(cx));
      args.rval().setUndefined();
      return true;
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.texSubImage3D");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo texSubImage3D_methodinfo = {
  { (JSJitGetterOp)texSubImage3D },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
copyTexSubImage3D(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 9)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.copyTexSubImage3D");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  int32_t arg2;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  int32_t arg5;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  int32_t arg6;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[6], &arg6)) {
    return false;
  }
  int32_t arg7;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[7], &arg7)) {
    return false;
  }
  int32_t arg8;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[8], &arg8)) {
    return false;
  }
  self->CopyTexSubImage3D(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo copyTexSubImage3D_methodinfo = {
  { (JSJitGetterOp)copyTexSubImage3D },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
compressedTexImage3D(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 9)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.compressedTexImage3D");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  int32_t arg5;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  int32_t arg6;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[6], &arg6)) {
    return false;
  }
  int32_t arg7;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[7], &arg7)) {
    return false;
  }
  RootedTypedArray<ArrayBufferView> arg8(cx);
  if (args[8].isObject()) {
    if (!arg8.Init(&args[8].toObject())) {
      ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 9 of WebGL2RenderingContext.compressedTexImage3D", "ArrayBufferView");
      return false;
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 9 of WebGL2RenderingContext.compressedTexImage3D");
    return false;
  }
  self->CompressedTexImage3D(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, Constify(arg8));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo compressedTexImage3D_methodinfo = {
  { (JSJitGetterOp)compressedTexImage3D },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
compressedTexSubImage3D(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 11)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.compressedTexSubImage3D");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  int32_t arg2;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  int32_t arg5;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  int32_t arg6;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[6], &arg6)) {
    return false;
  }
  int32_t arg7;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[7], &arg7)) {
    return false;
  }
  uint32_t arg8;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[8], &arg8)) {
    return false;
  }
  int32_t arg9;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[9], &arg9)) {
    return false;
  }
  RootedTypedArray<ArrayBufferView> arg10(cx);
  if (args[10].isObject()) {
    if (!arg10.Init(&args[10].toObject())) {
      ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 11 of WebGL2RenderingContext.compressedTexSubImage3D", "ArrayBufferView");
      return false;
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 11 of WebGL2RenderingContext.compressedTexSubImage3D");
    return false;
  }
  self->CompressedTexSubImage3D(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, Constify(arg10));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo compressedTexSubImage3D_methodinfo = {
  { (JSJitGetterOp)compressedTexSubImage3D },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getFragDataLocation(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getFragDataLocation");
  }
  mozilla::WebGLProgram* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLProgram, mozilla::WebGLProgram>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.getFragDataLocation", "WebGLProgram");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.getFragDataLocation");
    return false;
  }
  binding_detail::FakeString arg1;
  if (!ConvertJSValueToString(cx, args[1], eStringify, eStringify, arg1)) {
    return false;
  }
  int32_t result(self->GetFragDataLocation(Constify(arg0), NonNullHelper(Constify(arg1))));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo getFragDataLocation_methodinfo = {
  { (JSJitGetterOp)getFragDataLocation },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniform1ui(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniform1ui");
  }
  mozilla::WebGLUniformLocation* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniform1ui", "WebGLUniformLocation");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniform1ui");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  self->Uniform1ui(Constify(arg0), arg1);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo uniform1ui_methodinfo = {
  { (JSJitGetterOp)uniform1ui },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniform2ui(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniform2ui");
  }
  mozilla::WebGLUniformLocation* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniform2ui", "WebGLUniformLocation");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniform2ui");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  self->Uniform2ui(Constify(arg0), arg1, arg2);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo uniform2ui_methodinfo = {
  { (JSJitGetterOp)uniform2ui },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniform3ui(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 4)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniform3ui");
  }
  mozilla::WebGLUniformLocation* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniform3ui", "WebGLUniformLocation");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniform3ui");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  uint32_t arg3;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  self->Uniform3ui(Constify(arg0), arg1, arg2, arg3);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo uniform3ui_methodinfo = {
  { (JSJitGetterOp)uniform3ui },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniform4ui(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 5)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniform4ui");
  }
  mozilla::WebGLUniformLocation* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniform4ui", "WebGLUniformLocation");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniform4ui");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  uint32_t arg3;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  uint32_t arg4;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  self->Uniform4ui(Constify(arg0), arg1, arg2, arg3, arg4);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo uniform4ui_methodinfo = {
  { (JSJitGetterOp)uniform4ui },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniform1uiv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 2u);
  switch (argcount) {
    case 2: {
      mozilla::WebGLUniformLocation* arg0;
      if (args[0].isObject()) {
        {
          nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniform1uiv", "WebGLUniformLocation");
            return false;
          }
        }
      } else if (args[0].isNullOrUndefined()) {
        arg0 = nullptr;
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniform1uiv");
        return false;
      }
      if (args[1].isObject()) {
        do {
          RootedTypedArray<Uint32Array> arg1(cx);
          if (!arg1.Init(&args[1].toObject())) {
            break;
          }
          self->Uniform1uiv(Constify(arg0), Constify(arg1));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<uint32_t> arg1;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<uint32_t> &arr = arg1;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            uint32_t* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            uint32_t& slot = *slotPtr;
            if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->Uniform1uiv(Constify(arg0), Constify(arg1));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "2", "2", "WebGL2RenderingContext.uniform1uiv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniform1uiv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo uniform1uiv_methodinfo = {
  { (JSJitGetterOp)uniform1uiv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniform2uiv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 2u);
  switch (argcount) {
    case 2: {
      mozilla::WebGLUniformLocation* arg0;
      if (args[0].isObject()) {
        {
          nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniform2uiv", "WebGLUniformLocation");
            return false;
          }
        }
      } else if (args[0].isNullOrUndefined()) {
        arg0 = nullptr;
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniform2uiv");
        return false;
      }
      if (args[1].isObject()) {
        do {
          RootedTypedArray<Uint32Array> arg1(cx);
          if (!arg1.Init(&args[1].toObject())) {
            break;
          }
          self->Uniform2uiv(Constify(arg0), Constify(arg1));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<uint32_t> arg1;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<uint32_t> &arr = arg1;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            uint32_t* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            uint32_t& slot = *slotPtr;
            if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->Uniform2uiv(Constify(arg0), Constify(arg1));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "2", "2", "WebGL2RenderingContext.uniform2uiv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniform2uiv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo uniform2uiv_methodinfo = {
  { (JSJitGetterOp)uniform2uiv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniform3uiv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 2u);
  switch (argcount) {
    case 2: {
      mozilla::WebGLUniformLocation* arg0;
      if (args[0].isObject()) {
        {
          nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniform3uiv", "WebGLUniformLocation");
            return false;
          }
        }
      } else if (args[0].isNullOrUndefined()) {
        arg0 = nullptr;
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniform3uiv");
        return false;
      }
      if (args[1].isObject()) {
        do {
          RootedTypedArray<Uint32Array> arg1(cx);
          if (!arg1.Init(&args[1].toObject())) {
            break;
          }
          self->Uniform3uiv(Constify(arg0), Constify(arg1));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<uint32_t> arg1;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<uint32_t> &arr = arg1;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            uint32_t* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            uint32_t& slot = *slotPtr;
            if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->Uniform3uiv(Constify(arg0), Constify(arg1));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "2", "2", "WebGL2RenderingContext.uniform3uiv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniform3uiv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo uniform3uiv_methodinfo = {
  { (JSJitGetterOp)uniform3uiv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniform4uiv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 2u);
  switch (argcount) {
    case 2: {
      mozilla::WebGLUniformLocation* arg0;
      if (args[0].isObject()) {
        {
          nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniform4uiv", "WebGLUniformLocation");
            return false;
          }
        }
      } else if (args[0].isNullOrUndefined()) {
        arg0 = nullptr;
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniform4uiv");
        return false;
      }
      if (args[1].isObject()) {
        do {
          RootedTypedArray<Uint32Array> arg1(cx);
          if (!arg1.Init(&args[1].toObject())) {
            break;
          }
          self->Uniform4uiv(Constify(arg0), Constify(arg1));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<uint32_t> arg1;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<uint32_t> &arr = arg1;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            uint32_t* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            uint32_t& slot = *slotPtr;
            if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->Uniform4uiv(Constify(arg0), Constify(arg1));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "2", "2", "WebGL2RenderingContext.uniform4uiv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniform4uiv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo uniform4uiv_methodinfo = {
  { (JSJitGetterOp)uniform4uiv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniformMatrix2x3fv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 3u);
  switch (argcount) {
    case 3: {
      mozilla::WebGLUniformLocation* arg0;
      if (args[0].isObject()) {
        {
          nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniformMatrix2x3fv", "WebGLUniformLocation");
            return false;
          }
        }
      } else if (args[0].isNullOrUndefined()) {
        arg0 = nullptr;
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniformMatrix2x3fv");
        return false;
      }
      bool arg1;
      if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      if (args[2].isObject()) {
        do {
          RootedTypedArray<Float32Array> arg2(cx);
          if (!arg2.Init(&args[2].toObject())) {
            break;
          }
          self->UniformMatrix2x3fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<float> arg2;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[2], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<float> &arr = arg2;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            float* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            float& slot = *slotPtr;
            if (!ValueToPrimitive<float, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->UniformMatrix2x3fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "3", "3", "WebGL2RenderingContext.uniformMatrix2x3fv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniformMatrix2x3fv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo uniformMatrix2x3fv_methodinfo = {
  { (JSJitGetterOp)uniformMatrix2x3fv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniformMatrix3x2fv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 3u);
  switch (argcount) {
    case 3: {
      mozilla::WebGLUniformLocation* arg0;
      if (args[0].isObject()) {
        {
          nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniformMatrix3x2fv", "WebGLUniformLocation");
            return false;
          }
        }
      } else if (args[0].isNullOrUndefined()) {
        arg0 = nullptr;
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniformMatrix3x2fv");
        return false;
      }
      bool arg1;
      if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      if (args[2].isObject()) {
        do {
          RootedTypedArray<Float32Array> arg2(cx);
          if (!arg2.Init(&args[2].toObject())) {
            break;
          }
          self->UniformMatrix3x2fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<float> arg2;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[2], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<float> &arr = arg2;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            float* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            float& slot = *slotPtr;
            if (!ValueToPrimitive<float, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->UniformMatrix3x2fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "3", "3", "WebGL2RenderingContext.uniformMatrix3x2fv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniformMatrix3x2fv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo uniformMatrix3x2fv_methodinfo = {
  { (JSJitGetterOp)uniformMatrix3x2fv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniformMatrix2x4fv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 3u);
  switch (argcount) {
    case 3: {
      mozilla::WebGLUniformLocation* arg0;
      if (args[0].isObject()) {
        {
          nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniformMatrix2x4fv", "WebGLUniformLocation");
            return false;
          }
        }
      } else if (args[0].isNullOrUndefined()) {
        arg0 = nullptr;
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniformMatrix2x4fv");
        return false;
      }
      bool arg1;
      if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      if (args[2].isObject()) {
        do {
          RootedTypedArray<Float32Array> arg2(cx);
          if (!arg2.Init(&args[2].toObject())) {
            break;
          }
          self->UniformMatrix2x4fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<float> arg2;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[2], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<float> &arr = arg2;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            float* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            float& slot = *slotPtr;
            if (!ValueToPrimitive<float, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->UniformMatrix2x4fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "3", "3", "WebGL2RenderingContext.uniformMatrix2x4fv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniformMatrix2x4fv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo uniformMatrix2x4fv_methodinfo = {
  { (JSJitGetterOp)uniformMatrix2x4fv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniformMatrix4x2fv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 3u);
  switch (argcount) {
    case 3: {
      mozilla::WebGLUniformLocation* arg0;
      if (args[0].isObject()) {
        {
          nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniformMatrix4x2fv", "WebGLUniformLocation");
            return false;
          }
        }
      } else if (args[0].isNullOrUndefined()) {
        arg0 = nullptr;
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniformMatrix4x2fv");
        return false;
      }
      bool arg1;
      if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      if (args[2].isObject()) {
        do {
          RootedTypedArray<Float32Array> arg2(cx);
          if (!arg2.Init(&args[2].toObject())) {
            break;
          }
          self->UniformMatrix4x2fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<float> arg2;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[2], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<float> &arr = arg2;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            float* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            float& slot = *slotPtr;
            if (!ValueToPrimitive<float, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->UniformMatrix4x2fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "3", "3", "WebGL2RenderingContext.uniformMatrix4x2fv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniformMatrix4x2fv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo uniformMatrix4x2fv_methodinfo = {
  { (JSJitGetterOp)uniformMatrix4x2fv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniformMatrix3x4fv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 3u);
  switch (argcount) {
    case 3: {
      mozilla::WebGLUniformLocation* arg0;
      if (args[0].isObject()) {
        {
          nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniformMatrix3x4fv", "WebGLUniformLocation");
            return false;
          }
        }
      } else if (args[0].isNullOrUndefined()) {
        arg0 = nullptr;
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniformMatrix3x4fv");
        return false;
      }
      bool arg1;
      if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      if (args[2].isObject()) {
        do {
          RootedTypedArray<Float32Array> arg2(cx);
          if (!arg2.Init(&args[2].toObject())) {
            break;
          }
          self->UniformMatrix3x4fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<float> arg2;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[2], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<float> &arr = arg2;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            float* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            float& slot = *slotPtr;
            if (!ValueToPrimitive<float, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->UniformMatrix3x4fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "3", "3", "WebGL2RenderingContext.uniformMatrix3x4fv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniformMatrix3x4fv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo uniformMatrix3x4fv_methodinfo = {
  { (JSJitGetterOp)uniformMatrix3x4fv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniformMatrix4x3fv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 3u);
  switch (argcount) {
    case 3: {
      mozilla::WebGLUniformLocation* arg0;
      if (args[0].isObject()) {
        {
          nsresult rv = UnwrapObject<prototypes::id::WebGLUniformLocation, mozilla::WebGLUniformLocation>(&args[0].toObject(), arg0);
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniformMatrix4x3fv", "WebGLUniformLocation");
            return false;
          }
        }
      } else if (args[0].isNullOrUndefined()) {
        arg0 = nullptr;
      } else {
        ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniformMatrix4x3fv");
        return false;
      }
      bool arg1;
      if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      if (args[2].isObject()) {
        do {
          RootedTypedArray<Float32Array> arg2(cx);
          if (!arg2.Init(&args[2].toObject())) {
            break;
          }
          self->UniformMatrix4x3fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<float> arg2;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[2], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<float> &arr = arg2;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            float* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            float& slot = *slotPtr;
            if (!ValueToPrimitive<float, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->UniformMatrix4x3fv(Constify(arg0), arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "3", "3", "WebGL2RenderingContext.uniformMatrix4x3fv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniformMatrix4x3fv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo uniformMatrix4x3fv_methodinfo = {
  { (JSJitGetterOp)uniformMatrix4x3fv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
vertexAttribI4i(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 5)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.vertexAttribI4i");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  int32_t arg2;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  self->VertexAttribI4i(arg0, arg1, arg2, arg3, arg4);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo vertexAttribI4i_methodinfo = {
  { (JSJitGetterOp)vertexAttribI4i },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
vertexAttribI4iv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.vertexAttribI4iv");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  binding_detail::AutoSequence<int32_t> arg1;
  if (args[1].isObject()) {
    JS::ForOfIterator iter(cx);
    if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.vertexAttribI4iv");
      return false;
    }
    binding_detail::AutoSequence<int32_t> &arr = arg1;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      int32_t* slotPtr = arr.AppendElement();
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      int32_t& slot = *slotPtr;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, temp, &slot)) {
        return false;
      }
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.vertexAttribI4iv");
    return false;
  }
  self->VertexAttribI4iv(arg0, Constify(arg1));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo vertexAttribI4iv_methodinfo = {
  { (JSJitGetterOp)vertexAttribI4iv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
vertexAttribI4ui(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 5)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.vertexAttribI4ui");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  uint32_t arg3;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  uint32_t arg4;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  self->VertexAttribI4ui(arg0, arg1, arg2, arg3, arg4);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo vertexAttribI4ui_methodinfo = {
  { (JSJitGetterOp)vertexAttribI4ui },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
vertexAttribI4uiv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.vertexAttribI4uiv");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  binding_detail::AutoSequence<uint32_t> arg1;
  if (args[1].isObject()) {
    JS::ForOfIterator iter(cx);
    if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.vertexAttribI4uiv");
      return false;
    }
    binding_detail::AutoSequence<uint32_t> &arr = arg1;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      uint32_t* slotPtr = arr.AppendElement();
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      uint32_t& slot = *slotPtr;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
        return false;
      }
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.vertexAttribI4uiv");
    return false;
  }
  self->VertexAttribI4uiv(arg0, Constify(arg1));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo vertexAttribI4uiv_methodinfo = {
  { (JSJitGetterOp)vertexAttribI4uiv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
vertexAttribIPointer(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 5)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.vertexAttribIPointer");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int64_t arg4;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  self->VertexAttribIPointer(arg0, arg1, arg2, arg3, arg4);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo vertexAttribIPointer_methodinfo = {
  { (JSJitGetterOp)vertexAttribIPointer },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
vertexAttribDivisor(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.vertexAttribDivisor");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  self->VertexAttribDivisor(arg0, arg1);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo vertexAttribDivisor_methodinfo = {
  { (JSJitGetterOp)vertexAttribDivisor },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
drawArraysInstanced(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 4)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.drawArraysInstanced");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  int32_t arg2;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  self->DrawArraysInstanced(arg0, arg1, arg2, arg3);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo drawArraysInstanced_methodinfo = {
  { (JSJitGetterOp)drawArraysInstanced },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
drawElementsInstanced(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 5)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.drawElementsInstanced");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int64_t arg3;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  self->DrawElementsInstanced(arg0, arg1, arg2, arg3, arg4);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo drawElementsInstanced_methodinfo = {
  { (JSJitGetterOp)drawElementsInstanced },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
drawRangeElements(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 6)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.drawRangeElements");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  uint32_t arg4;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  int64_t arg5;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  self->DrawRangeElements(arg0, arg1, arg2, arg3, arg4, arg5);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo drawRangeElements_methodinfo = {
  { (JSJitGetterOp)drawRangeElements },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
drawBuffers(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.drawBuffers");
  }
  binding_detail::AutoSequence<uint32_t> arg0;
  if (args[0].isObject()) {
    JS::ForOfIterator iter(cx);
    if (!iter.init(args[0], JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 1 of WebGL2RenderingContext.drawBuffers");
      return false;
    }
    binding_detail::AutoSequence<uint32_t> &arr = arg0;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      uint32_t* slotPtr = arr.AppendElement();
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      uint32_t& slot = *slotPtr;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
        return false;
      }
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 1 of WebGL2RenderingContext.drawBuffers");
    return false;
  }
  self->DrawBuffers(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo drawBuffers_methodinfo = {
  { (JSJitGetterOp)drawBuffers },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
clearBufferiv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 3u);
  switch (argcount) {
    case 3: {
      uint32_t arg0;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
        return false;
      }
      int32_t arg1;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      if (args[2].isObject()) {
        do {
          RootedTypedArray<Int32Array> arg2(cx);
          if (!arg2.Init(&args[2].toObject())) {
            break;
          }
          self->ClearBufferiv(arg0, arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<int32_t> arg2;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[2], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<int32_t> &arr = arg2;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            int32_t* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            int32_t& slot = *slotPtr;
            if (!ValueToPrimitive<int32_t, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->ClearBufferiv(arg0, arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "3", "3", "WebGL2RenderingContext.clearBufferiv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.clearBufferiv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo clearBufferiv_methodinfo = {
  { (JSJitGetterOp)clearBufferiv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
clearBufferuiv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 3u);
  switch (argcount) {
    case 3: {
      uint32_t arg0;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
        return false;
      }
      int32_t arg1;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      if (args[2].isObject()) {
        do {
          RootedTypedArray<Uint32Array> arg2(cx);
          if (!arg2.Init(&args[2].toObject())) {
            break;
          }
          self->ClearBufferuiv(arg0, arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<uint32_t> arg2;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[2], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<uint32_t> &arr = arg2;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            uint32_t* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            uint32_t& slot = *slotPtr;
            if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->ClearBufferuiv(arg0, arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "3", "3", "WebGL2RenderingContext.clearBufferuiv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.clearBufferuiv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo clearBufferuiv_methodinfo = {
  { (JSJitGetterOp)clearBufferuiv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
clearBufferfv(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  unsigned argcount = std::min(args.length(), 3u);
  switch (argcount) {
    case 3: {
      uint32_t arg0;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
        return false;
      }
      int32_t arg1;
      if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
        return false;
      }
      if (args[2].isObject()) {
        do {
          RootedTypedArray<Float32Array> arg2(cx);
          if (!arg2.Init(&args[2].toObject())) {
            break;
          }
          self->ClearBufferfv(arg0, arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
        do {
          binding_detail::AutoSequence<float> arg2;
          JS::ForOfIterator iter(cx);
          if (!iter.init(args[2], JS::ForOfIterator::AllowNonIterable)) {
            return false;
          }
          if (!iter.valueIsIterable()) {
            break;
          }
          binding_detail::AutoSequence<float> &arr = arg2;
          JS::Rooted<JS::Value> temp(cx);
          while (true) {
            bool done;
            if (!iter.next(&temp, &done)) {
              return false;
            }
            if (done) {
              break;
            }
            float* slotPtr = arr.AppendElement();
            if (!slotPtr) {
              JS_ReportOutOfMemory(cx);
              return false;
            }
            float& slot = *slotPtr;
            if (!ValueToPrimitive<float, eDefault>(cx, temp, &slot)) {
              return false;
            }
          }
          self->ClearBufferfv(arg0, arg1, Constify(arg2));
          MOZ_ASSERT(!JS_IsExceptionPending(cx));
          args.rval().setUndefined();
          return true;
        } while (0);
      }
      return ThrowErrorMessage(cx, MSG_OVERLOAD_RESOLUTION_FAILED, "3", "3", "WebGL2RenderingContext.clearBufferfv");
      break;
    }
    default: {
      return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.clearBufferfv");
      break;
    }
  }
  MOZ_CRASH("We have an always-returning default case");
  return false;
}

static const JSJitInfo clearBufferfv_methodinfo = {
  { (JSJitGetterOp)clearBufferfv },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
clearBufferfi(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 4)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.clearBufferfi");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  int32_t arg1;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  float arg2;
  if (!ValueToPrimitive<float, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  int32_t arg3;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  self->ClearBufferfi(arg0, arg1, arg2, arg3);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo clearBufferfi_methodinfo = {
  { (JSJitGetterOp)clearBufferfi },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
createQuery(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  auto result(StrongOrRawPtr<mozilla::WebGLQuery>(self->CreateQuery()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!GetOrCreateDOMReflector(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createQuery_methodinfo = {
  { (JSJitGetterOp)createQuery },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
deleteQuery(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.deleteQuery");
  }
  mozilla::WebGLQuery* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLQuery, mozilla::WebGLQuery>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.deleteQuery", "WebGLQuery");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.deleteQuery");
    return false;
  }
  self->DeleteQuery(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo deleteQuery_methodinfo = {
  { (JSJitGetterOp)deleteQuery },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
isQuery(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.isQuery");
  }
  mozilla::WebGLQuery* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLQuery, mozilla::WebGLQuery>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.isQuery", "WebGLQuery");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.isQuery");
    return false;
  }
  bool result(self->IsQuery(Constify(arg0)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isQuery_methodinfo = {
  { (JSJitGetterOp)isQuery },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
beginQuery(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.beginQuery");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  mozilla::WebGLQuery* arg1;
  if (args[1].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLQuery, mozilla::WebGLQuery>(&args[1].toObject(), arg1);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 2 of WebGL2RenderingContext.beginQuery", "WebGLQuery");
        return false;
      }
    }
  } else if (args[1].isNullOrUndefined()) {
    arg1 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 2 of WebGL2RenderingContext.beginQuery");
    return false;
  }
  self->BeginQuery(arg0, Constify(arg1));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo beginQuery_methodinfo = {
  { (JSJitGetterOp)beginQuery },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
endQuery(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.endQuery");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  self->EndQuery(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo endQuery_methodinfo = {
  { (JSJitGetterOp)endQuery },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getQuery(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getQuery");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::WebGLQuery>(self->GetQuery(arg0, arg1)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!GetOrCreateDOMReflector(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo getQuery_methodinfo = {
  { (JSJitGetterOp)getQuery },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getQueryParameter(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getQueryParameter");
  }
  mozilla::WebGLQuery* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLQuery, mozilla::WebGLQuery>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.getQueryParameter", "WebGLQuery");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.getQueryParameter");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  JS::Rooted<JS::Value> result(cx);
  self->GetQueryParameter(cx, Constify(arg0), arg1, &result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  JS::ExposeValueToActiveJS(result);
  args.rval().set(result);
  if (!MaybeWrapValue(cx, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo getQueryParameter_methodinfo = {
  { (JSJitGetterOp)getQueryParameter },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
createSampler(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  auto result(StrongOrRawPtr<mozilla::WebGLSampler>(self->CreateSampler()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!GetOrCreateDOMReflector(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSampler_methodinfo = {
  { (JSJitGetterOp)createSampler },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
deleteSampler(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.deleteSampler");
  }
  mozilla::WebGLSampler* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSampler, mozilla::WebGLSampler>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.deleteSampler", "WebGLSampler");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.deleteSampler");
    return false;
  }
  self->DeleteSampler(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo deleteSampler_methodinfo = {
  { (JSJitGetterOp)deleteSampler },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
isSampler(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.isSampler");
  }
  mozilla::WebGLSampler* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSampler, mozilla::WebGLSampler>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.isSampler", "WebGLSampler");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.isSampler");
    return false;
  }
  bool result(self->IsSampler(Constify(arg0)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isSampler_methodinfo = {
  { (JSJitGetterOp)isSampler },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
bindSampler(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.bindSampler");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  mozilla::WebGLSampler* arg1;
  if (args[1].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSampler, mozilla::WebGLSampler>(&args[1].toObject(), arg1);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 2 of WebGL2RenderingContext.bindSampler", "WebGLSampler");
        return false;
      }
    }
  } else if (args[1].isNullOrUndefined()) {
    arg1 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 2 of WebGL2RenderingContext.bindSampler");
    return false;
  }
  self->BindSampler(arg0, Constify(arg1));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo bindSampler_methodinfo = {
  { (JSJitGetterOp)bindSampler },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
samplerParameteri(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.samplerParameteri");
  }
  mozilla::WebGLSampler* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSampler, mozilla::WebGLSampler>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.samplerParameteri", "WebGLSampler");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.samplerParameteri");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  int32_t arg2;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  self->SamplerParameteri(Constify(arg0), arg1, arg2);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo samplerParameteri_methodinfo = {
  { (JSJitGetterOp)samplerParameteri },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
samplerParameterf(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.samplerParameterf");
  }
  mozilla::WebGLSampler* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSampler, mozilla::WebGLSampler>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.samplerParameterf", "WebGLSampler");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.samplerParameterf");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  float arg2;
  if (!ValueToPrimitive<float, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  self->SamplerParameterf(Constify(arg0), arg1, arg2);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo samplerParameterf_methodinfo = {
  { (JSJitGetterOp)samplerParameterf },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getSamplerParameter(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getSamplerParameter");
  }
  mozilla::WebGLSampler* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSampler, mozilla::WebGLSampler>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.getSamplerParameter", "WebGLSampler");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.getSamplerParameter");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  JS::Rooted<JS::Value> result(cx);
  self->GetSamplerParameter(cx, Constify(arg0), arg1, &result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  JS::ExposeValueToActiveJS(result);
  args.rval().set(result);
  if (!MaybeWrapValue(cx, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo getSamplerParameter_methodinfo = {
  { (JSJitGetterOp)getSamplerParameter },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
fenceSync(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.fenceSync");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::WebGLSync>(self->FenceSync(arg0, arg1)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!GetOrCreateDOMReflector(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo fenceSync_methodinfo = {
  { (JSJitGetterOp)fenceSync },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
isSync(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.isSync");
  }
  mozilla::WebGLSync* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSync, mozilla::WebGLSync>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.isSync", "WebGLSync");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.isSync");
    return false;
  }
  bool result(self->IsSync(Constify(arg0)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isSync_methodinfo = {
  { (JSJitGetterOp)isSync },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
deleteSync(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.deleteSync");
  }
  mozilla::WebGLSync* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSync, mozilla::WebGLSync>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.deleteSync", "WebGLSync");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.deleteSync");
    return false;
  }
  self->DeleteSync(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo deleteSync_methodinfo = {
  { (JSJitGetterOp)deleteSync },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
clientWaitSync(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.clientWaitSync");
  }
  mozilla::WebGLSync* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSync, mozilla::WebGLSync>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.clientWaitSync", "WebGLSync");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.clientWaitSync");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  int64_t arg2;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  uint32_t result(self->ClientWaitSync(Constify(arg0), arg1, arg2));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setNumber(result);
  return true;
}

static const JSJitInfo clientWaitSync_methodinfo = {
  { (JSJitGetterOp)clientWaitSync },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
waitSync(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.waitSync");
  }
  mozilla::WebGLSync* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSync, mozilla::WebGLSync>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.waitSync", "WebGLSync");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.waitSync");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  int64_t arg2;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  self->WaitSync(Constify(arg0), arg1, arg2);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo waitSync_methodinfo = {
  { (JSJitGetterOp)waitSync },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getSyncParameter(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getSyncParameter");
  }
  mozilla::WebGLSync* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLSync, mozilla::WebGLSync>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.getSyncParameter", "WebGLSync");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.getSyncParameter");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  JS::Rooted<JS::Value> result(cx);
  self->GetSyncParameter(cx, Constify(arg0), arg1, &result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  JS::ExposeValueToActiveJS(result);
  args.rval().set(result);
  if (!MaybeWrapValue(cx, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo getSyncParameter_methodinfo = {
  { (JSJitGetterOp)getSyncParameter },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
createTransformFeedback(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  auto result(StrongOrRawPtr<mozilla::WebGLTransformFeedback>(self->CreateTransformFeedback()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!GetOrCreateDOMReflector(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createTransformFeedback_methodinfo = {
  { (JSJitGetterOp)createTransformFeedback },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
deleteTransformFeedback(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.deleteTransformFeedback");
  }
  mozilla::WebGLTransformFeedback* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLTransformFeedback, mozilla::WebGLTransformFeedback>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.deleteTransformFeedback", "WebGLTransformFeedback");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.deleteTransformFeedback");
    return false;
  }
  self->DeleteTransformFeedback(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo deleteTransformFeedback_methodinfo = {
  { (JSJitGetterOp)deleteTransformFeedback },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
isTransformFeedback(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.isTransformFeedback");
  }
  mozilla::WebGLTransformFeedback* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLTransformFeedback, mozilla::WebGLTransformFeedback>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.isTransformFeedback", "WebGLTransformFeedback");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.isTransformFeedback");
    return false;
  }
  bool result(self->IsTransformFeedback(Constify(arg0)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isTransformFeedback_methodinfo = {
  { (JSJitGetterOp)isTransformFeedback },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
bindTransformFeedback(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.bindTransformFeedback");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  mozilla::WebGLTransformFeedback* arg1;
  if (args[1].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLTransformFeedback, mozilla::WebGLTransformFeedback>(&args[1].toObject(), arg1);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 2 of WebGL2RenderingContext.bindTransformFeedback", "WebGLTransformFeedback");
        return false;
      }
    }
  } else if (args[1].isNullOrUndefined()) {
    arg1 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 2 of WebGL2RenderingContext.bindTransformFeedback");
    return false;
  }
  self->BindTransformFeedback(arg0, Constify(arg1));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo bindTransformFeedback_methodinfo = {
  { (JSJitGetterOp)bindTransformFeedback },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
beginTransformFeedback(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.beginTransformFeedback");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  self->BeginTransformFeedback(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo beginTransformFeedback_methodinfo = {
  { (JSJitGetterOp)beginTransformFeedback },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
endTransformFeedback(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  self->EndTransformFeedback();
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo endTransformFeedback_methodinfo = {
  { (JSJitGetterOp)endTransformFeedback },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
transformFeedbackVaryings(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.transformFeedbackVaryings");
  }
  mozilla::WebGLProgram* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLProgram, mozilla::WebGLProgram>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.transformFeedbackVaryings", "WebGLProgram");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.transformFeedbackVaryings");
    return false;
  }
  binding_detail::AutoSequence<nsString> arg1;
  if (args[1].isObject()) {
    JS::ForOfIterator iter(cx);
    if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.transformFeedbackVaryings");
      return false;
    }
    binding_detail::AutoSequence<nsString> &arr = arg1;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      nsString* slotPtr = arr.AppendElement();
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      nsString& slot = *slotPtr;
      if (!ConvertJSValueToString(cx, temp, eStringify, eStringify, slot)) {
        return false;
      }
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.transformFeedbackVaryings");
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  self->TransformFeedbackVaryings(Constify(arg0), Constify(arg1), arg2);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo transformFeedbackVaryings_methodinfo = {
  { (JSJitGetterOp)transformFeedbackVaryings },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getTransformFeedbackVarying(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getTransformFeedbackVarying");
  }
  mozilla::WebGLProgram* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLProgram, mozilla::WebGLProgram>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.getTransformFeedbackVarying", "WebGLProgram");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.getTransformFeedbackVarying");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::WebGLActiveInfo>(self->GetTransformFeedbackVarying(Constify(arg0), arg1)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!GetOrCreateDOMReflector(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo getTransformFeedbackVarying_methodinfo = {
  { (JSJitGetterOp)getTransformFeedbackVarying },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
pauseTransformFeedback(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  self->PauseTransformFeedback();
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo pauseTransformFeedback_methodinfo = {
  { (JSJitGetterOp)pauseTransformFeedback },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
resumeTransformFeedback(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  self->ResumeTransformFeedback();
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo resumeTransformFeedback_methodinfo = {
  { (JSJitGetterOp)resumeTransformFeedback },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
bindBufferBase(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.bindBufferBase");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  mozilla::WebGLBuffer* arg2;
  if (args[2].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLBuffer, mozilla::WebGLBuffer>(&args[2].toObject(), arg2);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 3 of WebGL2RenderingContext.bindBufferBase", "WebGLBuffer");
        return false;
      }
    }
  } else if (args[2].isNullOrUndefined()) {
    arg2 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 3 of WebGL2RenderingContext.bindBufferBase");
    return false;
  }
  self->BindBufferBase(arg0, arg1, Constify(arg2));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo bindBufferBase_methodinfo = {
  { (JSJitGetterOp)bindBufferBase },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
bindBufferRange(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 5)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.bindBufferRange");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  mozilla::WebGLBuffer* arg2;
  if (args[2].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLBuffer, mozilla::WebGLBuffer>(&args[2].toObject(), arg2);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 3 of WebGL2RenderingContext.bindBufferRange", "WebGLBuffer");
        return false;
      }
    }
  } else if (args[2].isNullOrUndefined()) {
    arg2 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 3 of WebGL2RenderingContext.bindBufferRange");
    return false;
  }
  int64_t arg3;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[3], &arg3)) {
    return false;
  }
  int64_t arg4;
  if (!ValueToPrimitive<int64_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  self->BindBufferRange(arg0, arg1, Constify(arg2), arg3, arg4);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo bindBufferRange_methodinfo = {
  { (JSJitGetterOp)bindBufferRange },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getIndexedParameter(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getIndexedParameter");
  }
  uint32_t arg0;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  Nullable<OwningWebGLBufferOrLongLong> result;
  self->GetIndexedParameter(arg0, arg1, result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result.IsNull()) {
    args.rval().setNull();
    return true;
  }
  if (!result.Value().ToJSVal(cx, obj, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo getIndexedParameter_methodinfo = {
  { (JSJitGetterOp)getIndexedParameter },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getUniformIndices(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getUniformIndices");
  }
  mozilla::WebGLProgram* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLProgram, mozilla::WebGLProgram>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.getUniformIndices", "WebGLProgram");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.getUniformIndices");
    return false;
  }
  binding_detail::AutoSequence<nsString> arg1;
  if (args[1].isObject()) {
    JS::ForOfIterator iter(cx);
    if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.getUniformIndices");
      return false;
    }
    binding_detail::AutoSequence<nsString> &arr = arg1;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      nsString* slotPtr = arr.AppendElement();
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      nsString& slot = *slotPtr;
      if (!ConvertJSValueToString(cx, temp, eStringify, eStringify, slot)) {
        return false;
      }
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.getUniformIndices");
    return false;
  }
  Nullable<nsTArray<uint32_t>> result;
  self->GetUniformIndices(Constify(arg0), Constify(arg1), result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  if (result.IsNull()) {
    args.rval().setNull();
    return true;
  }

  uint32_t length = result.Value().Length();
  JS::Rooted<JSObject*> returnArray(cx, JS_NewArrayObject(cx, length));
  if (!returnArray) {
    return false;
  }
  // Scope for 'tmp'
  {
    JS::Rooted<JS::Value> tmp(cx);
    for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
      // Control block to let us common up the JS_DefineElement calls when there
      // are different ways to succeed at wrapping the object.
      do {
        tmp.setNumber(result.Value()[sequenceIdx0]);
        break;
      } while (0);
      if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                            JSPROP_ENUMERATE)) {
        return false;
      }
    }
  }
  args.rval().setObject(*returnArray);
  return true;
}

static const JSJitInfo getUniformIndices_methodinfo = {
  { (JSJitGetterOp)getUniformIndices },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getActiveUniforms(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getActiveUniforms");
  }
  mozilla::WebGLProgram* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLProgram, mozilla::WebGLProgram>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.getActiveUniforms", "WebGLProgram");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.getActiveUniforms");
    return false;
  }
  binding_detail::AutoSequence<uint32_t> arg1;
  if (args[1].isObject()) {
    JS::ForOfIterator iter(cx);
    if (!iter.init(args[1], JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.getActiveUniforms");
      return false;
    }
    binding_detail::AutoSequence<uint32_t> &arr = arg1;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      uint32_t* slotPtr = arr.AppendElement();
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      uint32_t& slot = *slotPtr;
      if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
        return false;
      }
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "Argument 2 of WebGL2RenderingContext.getActiveUniforms");
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  Nullable<nsTArray<int32_t>> result;
  self->GetActiveUniforms(Constify(arg0), Constify(arg1), arg2, result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  if (result.IsNull()) {
    args.rval().setNull();
    return true;
  }

  uint32_t length = result.Value().Length();
  JS::Rooted<JSObject*> returnArray(cx, JS_NewArrayObject(cx, length));
  if (!returnArray) {
    return false;
  }
  // Scope for 'tmp'
  {
    JS::Rooted<JS::Value> tmp(cx);
    for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
      // Control block to let us common up the JS_DefineElement calls when there
      // are different ways to succeed at wrapping the object.
      do {
        tmp.setInt32(int32_t(result.Value()[sequenceIdx0]));
        break;
      } while (0);
      if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                            JSPROP_ENUMERATE)) {
        return false;
      }
    }
  }
  args.rval().setObject(*returnArray);
  return true;
}

static const JSJitInfo getActiveUniforms_methodinfo = {
  { (JSJitGetterOp)getActiveUniforms },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getUniformBlockIndex(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getUniformBlockIndex");
  }
  mozilla::WebGLProgram* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLProgram, mozilla::WebGLProgram>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.getUniformBlockIndex", "WebGLProgram");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.getUniformBlockIndex");
    return false;
  }
  binding_detail::FakeString arg1;
  if (!ConvertJSValueToString(cx, args[1], eStringify, eStringify, arg1)) {
    return false;
  }
  uint32_t result(self->GetUniformBlockIndex(Constify(arg0), NonNullHelper(Constify(arg1))));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setNumber(result);
  return true;
}

static const JSJitInfo getUniformBlockIndex_methodinfo = {
  { (JSJitGetterOp)getUniformBlockIndex },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getActiveUniformBlockParameter(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getActiveUniformBlockParameter");
  }
  mozilla::WebGLProgram* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLProgram, mozilla::WebGLProgram>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.getActiveUniformBlockParameter", "WebGLProgram");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.getActiveUniformBlockParameter");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  ErrorResult rv;
  NullableRootedUnion<OwningUnsignedLongOrUint32ArrayOrBoolean> result(cx);
  self->GetActiveUniformBlockParameter(cx, Constify(arg0), arg1, arg2, result, rv);
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailedWithDetails(cx, rv, "WebGL2RenderingContext", "getActiveUniformBlockParameter");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result.IsNull()) {
    args.rval().setNull();
    return true;
  }
  if (!result.Value().ToJSVal(cx, obj, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo getActiveUniformBlockParameter_methodinfo = {
  { (JSJitGetterOp)getActiveUniformBlockParameter },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getActiveUniformBlockName(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.getActiveUniformBlockName");
  }
  mozilla::WebGLProgram* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLProgram, mozilla::WebGLProgram>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.getActiveUniformBlockName", "WebGLProgram");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.getActiveUniformBlockName");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  DOMString result;
  self->GetActiveUniformBlockName(Constify(arg0), arg1, result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::StringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo getActiveUniformBlockName_methodinfo = {
  { (JSJitGetterOp)getActiveUniformBlockName },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
uniformBlockBinding(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::WebGL2Context* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 3)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "WebGL2RenderingContext.uniformBlockBinding");
  }
  mozilla::WebGLProgram* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::WebGLProgram, mozilla::WebGLProgram>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 1 of WebGL2RenderingContext.uniformBlockBinding", "WebGLProgram");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of WebGL2RenderingContext.uniformBlockBinding");
    return false;
  }
  uint32_t arg1;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  uint32_t arg2;
  if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  self->UniformBlockBinding(Constify(arg0), arg1, arg2);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo uniformBlockBinding_methodinfo = {
  { (JSJitGetterOp)uniformBlockBinding },
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::WebGL2Context* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGL2Context>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::WebGL2Context* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGL2Context>(obj);
  if (self) {
    JSBindingFinalized<mozilla::WebGL2Context>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::WebGL2Context>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::WebGL2Context* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGL2Context>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("copyBufferSubData", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&copyBufferSubData_methodinfo), 5, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getBufferSubData", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getBufferSubData_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("blitFramebuffer", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&blitFramebuffer_methodinfo), 10, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("framebufferTextureLayer", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&framebufferTextureLayer_methodinfo), 5, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getInternalformatParameter", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getInternalformatParameter_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("invalidateFramebuffer", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&invalidateFramebuffer_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("invalidateSubFramebuffer", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&invalidateSubFramebuffer_methodinfo), 6, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("readBuffer", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&readBuffer_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("renderbufferStorageMultisample", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&renderbufferStorageMultisample_methodinfo), 5, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("texStorage2D", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&texStorage2D_methodinfo), 5, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("texStorage3D", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&texStorage3D_methodinfo), 6, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("texImage3D", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&texImage3D_methodinfo), 10, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("texSubImage3D", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&texSubImage3D_methodinfo), 8, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("copyTexSubImage3D", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&copyTexSubImage3D_methodinfo), 9, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("compressedTexImage3D", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&compressedTexImage3D_methodinfo), 9, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("compressedTexSubImage3D", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&compressedTexSubImage3D_methodinfo), 11, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getFragDataLocation", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getFragDataLocation_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniform1ui", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniform1ui_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniform2ui", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniform2ui_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniform3ui", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniform3ui_methodinfo), 4, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniform4ui", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniform4ui_methodinfo), 5, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniform1uiv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniform1uiv_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniform2uiv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniform2uiv_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniform3uiv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniform3uiv_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniform4uiv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniform4uiv_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniformMatrix2x3fv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniformMatrix2x3fv_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniformMatrix3x2fv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniformMatrix3x2fv_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniformMatrix2x4fv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniformMatrix2x4fv_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniformMatrix4x2fv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniformMatrix4x2fv_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniformMatrix3x4fv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniformMatrix3x4fv_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniformMatrix4x3fv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniformMatrix4x3fv_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("vertexAttribI4i", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&vertexAttribI4i_methodinfo), 5, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("vertexAttribI4iv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&vertexAttribI4iv_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("vertexAttribI4ui", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&vertexAttribI4ui_methodinfo), 5, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("vertexAttribI4uiv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&vertexAttribI4uiv_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("vertexAttribIPointer", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&vertexAttribIPointer_methodinfo), 5, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("vertexAttribDivisor", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&vertexAttribDivisor_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("drawArraysInstanced", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&drawArraysInstanced_methodinfo), 4, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("drawElementsInstanced", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&drawElementsInstanced_methodinfo), 5, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("drawRangeElements", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&drawRangeElements_methodinfo), 6, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("drawBuffers", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&drawBuffers_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("clearBufferiv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&clearBufferiv_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("clearBufferuiv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&clearBufferuiv_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("clearBufferfv", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&clearBufferfv_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("clearBufferfi", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&clearBufferfi_methodinfo), 4, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createQuery", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createQuery_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("deleteQuery", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&deleteQuery_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("isQuery", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&isQuery_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("beginQuery", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&beginQuery_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("endQuery", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&endQuery_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getQuery", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getQuery_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getQueryParameter", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getQueryParameter_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSampler", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSampler_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("deleteSampler", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&deleteSampler_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("isSampler", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&isSampler_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("bindSampler", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&bindSampler_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("samplerParameteri", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&samplerParameteri_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("samplerParameterf", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&samplerParameterf_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getSamplerParameter", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getSamplerParameter_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("fenceSync", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&fenceSync_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("isSync", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&isSync_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("deleteSync", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&deleteSync_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("clientWaitSync", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&clientWaitSync_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("waitSync", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&waitSync_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getSyncParameter", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getSyncParameter_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createTransformFeedback", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createTransformFeedback_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("deleteTransformFeedback", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&deleteTransformFeedback_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("isTransformFeedback", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&isTransformFeedback_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("bindTransformFeedback", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&bindTransformFeedback_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("beginTransformFeedback", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&beginTransformFeedback_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("endTransformFeedback", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&endTransformFeedback_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("transformFeedbackVaryings", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&transformFeedbackVaryings_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getTransformFeedbackVarying", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getTransformFeedbackVarying_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("pauseTransformFeedback", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&pauseTransformFeedback_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("resumeTransformFeedback", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&resumeTransformFeedback_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("bindBufferBase", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&bindBufferBase_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("bindBufferRange", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&bindBufferRange_methodinfo), 5, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getIndexedParameter", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getIndexedParameter_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getUniformIndices", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getUniformIndices_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getActiveUniforms", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getActiveUniforms_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getUniformBlockIndex", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getUniformBlockIndex_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getActiveUniformBlockParameter", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getActiveUniformBlockParameter_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getActiveUniformBlockName", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getActiveUniformBlockName_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("uniformBlockBinding", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&uniformBlockBinding_methodinfo), 3, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, nullptr }
};

static jsid sMethods_ids[85];

static const ConstantSpec sConstants_specs[] = {
  { "READ_BUFFER", UINT_TO_JSVAL(3074U) },
  { "UNPACK_ROW_LENGTH", UINT_TO_JSVAL(3314U) },
  { "UNPACK_SKIP_ROWS", UINT_TO_JSVAL(3315U) },
  { "UNPACK_SKIP_PIXELS", UINT_TO_JSVAL(3316U) },
  { "PACK_ROW_LENGTH", UINT_TO_JSVAL(3330U) },
  { "PACK_SKIP_ROWS", UINT_TO_JSVAL(3331U) },
  { "PACK_SKIP_PIXELS", UINT_TO_JSVAL(3332U) },
  { "COLOR", UINT_TO_JSVAL(6144U) },
  { "DEPTH", UINT_TO_JSVAL(6145U) },
  { "STENCIL", UINT_TO_JSVAL(6146U) },
  { "RED", UINT_TO_JSVAL(6403U) },
  { "RGB8", UINT_TO_JSVAL(32849U) },
  { "RGBA8", UINT_TO_JSVAL(32856U) },
  { "RGB10_A2", UINT_TO_JSVAL(32857U) },
  { "TEXTURE_BINDING_3D", UINT_TO_JSVAL(32874U) },
  { "UNPACK_SKIP_IMAGES", UINT_TO_JSVAL(32877U) },
  { "UNPACK_IMAGE_HEIGHT", UINT_TO_JSVAL(32878U) },
  { "TEXTURE_3D", UINT_TO_JSVAL(32879U) },
  { "TEXTURE_WRAP_R", UINT_TO_JSVAL(32882U) },
  { "MAX_3D_TEXTURE_SIZE", UINT_TO_JSVAL(32883U) },
  { "UNSIGNED_INT_2_10_10_10_REV", UINT_TO_JSVAL(33640U) },
  { "MAX_ELEMENTS_VERTICES", UINT_TO_JSVAL(33000U) },
  { "MAX_ELEMENTS_INDICES", UINT_TO_JSVAL(33001U) },
  { "TEXTURE_MIN_LOD", UINT_TO_JSVAL(33082U) },
  { "TEXTURE_MAX_LOD", UINT_TO_JSVAL(33083U) },
  { "TEXTURE_BASE_LEVEL", UINT_TO_JSVAL(33084U) },
  { "TEXTURE_MAX_LEVEL", UINT_TO_JSVAL(33085U) },
  { "MIN", UINT_TO_JSVAL(32775U) },
  { "MAX", UINT_TO_JSVAL(32776U) },
  { "DEPTH_COMPONENT24", UINT_TO_JSVAL(33190U) },
  { "MAX_TEXTURE_LOD_BIAS", UINT_TO_JSVAL(34045U) },
  { "TEXTURE_COMPARE_MODE", UINT_TO_JSVAL(34892U) },
  { "TEXTURE_COMPARE_FUNC", UINT_TO_JSVAL(34893U) },
  { "CURRENT_QUERY", UINT_TO_JSVAL(34917U) },
  { "QUERY_RESULT", UINT_TO_JSVAL(34918U) },
  { "QUERY_RESULT_AVAILABLE", UINT_TO_JSVAL(34919U) },
  { "STREAM_READ", UINT_TO_JSVAL(35041U) },
  { "STREAM_COPY", UINT_TO_JSVAL(35042U) },
  { "STATIC_READ", UINT_TO_JSVAL(35045U) },
  { "STATIC_COPY", UINT_TO_JSVAL(35046U) },
  { "DYNAMIC_READ", UINT_TO_JSVAL(35049U) },
  { "DYNAMIC_COPY", UINT_TO_JSVAL(35050U) },
  { "MAX_DRAW_BUFFERS", UINT_TO_JSVAL(34852U) },
  { "DRAW_BUFFER0", UINT_TO_JSVAL(34853U) },
  { "DRAW_BUFFER1", UINT_TO_JSVAL(34854U) },
  { "DRAW_BUFFER2", UINT_TO_JSVAL(34855U) },
  { "DRAW_BUFFER3", UINT_TO_JSVAL(34856U) },
  { "DRAW_BUFFER4", UINT_TO_JSVAL(34857U) },
  { "DRAW_BUFFER5", UINT_TO_JSVAL(34858U) },
  { "DRAW_BUFFER6", UINT_TO_JSVAL(34859U) },
  { "DRAW_BUFFER7", UINT_TO_JSVAL(34860U) },
  { "DRAW_BUFFER8", UINT_TO_JSVAL(34861U) },
  { "DRAW_BUFFER9", UINT_TO_JSVAL(34862U) },
  { "DRAW_BUFFER10", UINT_TO_JSVAL(34863U) },
  { "DRAW_BUFFER11", UINT_TO_JSVAL(34864U) },
  { "DRAW_BUFFER12", UINT_TO_JSVAL(34865U) },
  { "DRAW_BUFFER13", UINT_TO_JSVAL(34866U) },
  { "DRAW_BUFFER14", UINT_TO_JSVAL(34867U) },
  { "DRAW_BUFFER15", UINT_TO_JSVAL(34868U) },
  { "MAX_FRAGMENT_UNIFORM_COMPONENTS", UINT_TO_JSVAL(35657U) },
  { "MAX_VERTEX_UNIFORM_COMPONENTS", UINT_TO_JSVAL(35658U) },
  { "SAMPLER_3D", UINT_TO_JSVAL(35679U) },
  { "SAMPLER_2D_SHADOW", UINT_TO_JSVAL(35682U) },
  { "FRAGMENT_SHADER_DERIVATIVE_HINT", UINT_TO_JSVAL(35723U) },
  { "PIXEL_PACK_BUFFER", UINT_TO_JSVAL(35051U) },
  { "PIXEL_UNPACK_BUFFER", UINT_TO_JSVAL(35052U) },
  { "PIXEL_PACK_BUFFER_BINDING", UINT_TO_JSVAL(35053U) },
  { "PIXEL_UNPACK_BUFFER_BINDING", UINT_TO_JSVAL(35055U) },
  { "FLOAT_MAT2x3", UINT_TO_JSVAL(35685U) },
  { "FLOAT_MAT2x4", UINT_TO_JSVAL(35686U) },
  { "FLOAT_MAT3x2", UINT_TO_JSVAL(35687U) },
  { "FLOAT_MAT3x4", UINT_TO_JSVAL(35688U) },
  { "FLOAT_MAT4x2", UINT_TO_JSVAL(35689U) },
  { "FLOAT_MAT4x3", UINT_TO_JSVAL(35690U) },
  { "SRGB", UINT_TO_JSVAL(35904U) },
  { "SRGB8", UINT_TO_JSVAL(35905U) },
  { "SRGB8_ALPHA8", UINT_TO_JSVAL(35907U) },
  { "COMPARE_REF_TO_TEXTURE", UINT_TO_JSVAL(34894U) },
  { "RGBA32F", UINT_TO_JSVAL(34836U) },
  { "RGB32F", UINT_TO_JSVAL(34837U) },
  { "RGBA16F", UINT_TO_JSVAL(34842U) },
  { "RGB16F", UINT_TO_JSVAL(34843U) },
  { "VERTEX_ATTRIB_ARRAY_INTEGER", UINT_TO_JSVAL(35069U) },
  { "MAX_ARRAY_TEXTURE_LAYERS", UINT_TO_JSVAL(35071U) },
  { "MIN_PROGRAM_TEXEL_OFFSET", UINT_TO_JSVAL(35076U) },
  { "MAX_PROGRAM_TEXEL_OFFSET", UINT_TO_JSVAL(35077U) },
  { "MAX_VARYING_COMPONENTS", UINT_TO_JSVAL(35659U) },
  { "TEXTURE_2D_ARRAY", UINT_TO_JSVAL(35866U) },
  { "TEXTURE_BINDING_2D_ARRAY", UINT_TO_JSVAL(35869U) },
  { "R11F_G11F_B10F", UINT_TO_JSVAL(35898U) },
  { "UNSIGNED_INT_10F_11F_11F_REV", UINT_TO_JSVAL(35899U) },
  { "RGB9_E5", UINT_TO_JSVAL(35901U) },
  { "UNSIGNED_INT_5_9_9_9_REV", UINT_TO_JSVAL(35902U) },
  { "TRANSFORM_FEEDBACK_BUFFER_MODE", UINT_TO_JSVAL(35967U) },
  { "MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS", UINT_TO_JSVAL(35968U) },
  { "TRANSFORM_FEEDBACK_VARYINGS", UINT_TO_JSVAL(35971U) },
  { "TRANSFORM_FEEDBACK_BUFFER_START", UINT_TO_JSVAL(35972U) },
  { "TRANSFORM_FEEDBACK_BUFFER_SIZE", UINT_TO_JSVAL(35973U) },
  { "TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN", UINT_TO_JSVAL(35976U) },
  { "RASTERIZER_DISCARD", UINT_TO_JSVAL(35977U) },
  { "MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS", UINT_TO_JSVAL(35978U) },
  { "MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS", UINT_TO_JSVAL(35979U) },
  { "INTERLEAVED_ATTRIBS", UINT_TO_JSVAL(35980U) },
  { "SEPARATE_ATTRIBS", UINT_TO_JSVAL(35981U) },
  { "TRANSFORM_FEEDBACK_BUFFER", UINT_TO_JSVAL(35982U) },
  { "TRANSFORM_FEEDBACK_BUFFER_BINDING", UINT_TO_JSVAL(35983U) },
  { "RGBA32UI", UINT_TO_JSVAL(36208U) },
  { "RGB32UI", UINT_TO_JSVAL(36209U) },
  { "RGBA16UI", UINT_TO_JSVAL(36214U) },
  { "RGB16UI", UINT_TO_JSVAL(36215U) },
  { "RGBA8UI", UINT_TO_JSVAL(36220U) },
  { "RGB8UI", UINT_TO_JSVAL(36221U) },
  { "RGBA32I", UINT_TO_JSVAL(36226U) },
  { "RGB32I", UINT_TO_JSVAL(36227U) },
  { "RGBA16I", UINT_TO_JSVAL(36232U) },
  { "RGB16I", UINT_TO_JSVAL(36233U) },
  { "RGBA8I", UINT_TO_JSVAL(36238U) },
  { "RGB8I", UINT_TO_JSVAL(36239U) },
  { "RED_INTEGER", UINT_TO_JSVAL(36244U) },
  { "RGB_INTEGER", UINT_TO_JSVAL(36248U) },
  { "RGBA_INTEGER", UINT_TO_JSVAL(36249U) },
  { "SAMPLER_2D_ARRAY", UINT_TO_JSVAL(36289U) },
  { "SAMPLER_2D_ARRAY_SHADOW", UINT_TO_JSVAL(36292U) },
  { "SAMPLER_CUBE_SHADOW", UINT_TO_JSVAL(36293U) },
  { "UNSIGNED_INT_VEC2", UINT_TO_JSVAL(36294U) },
  { "UNSIGNED_INT_VEC3", UINT_TO_JSVAL(36295U) },
  { "UNSIGNED_INT_VEC4", UINT_TO_JSVAL(36296U) },
  { "INT_SAMPLER_2D", UINT_TO_JSVAL(36298U) },
  { "INT_SAMPLER_3D", UINT_TO_JSVAL(36299U) },
  { "INT_SAMPLER_CUBE", UINT_TO_JSVAL(36300U) },
  { "INT_SAMPLER_2D_ARRAY", UINT_TO_JSVAL(36303U) },
  { "UNSIGNED_INT_SAMPLER_2D", UINT_TO_JSVAL(36306U) },
  { "UNSIGNED_INT_SAMPLER_3D", UINT_TO_JSVAL(36307U) },
  { "UNSIGNED_INT_SAMPLER_CUBE", UINT_TO_JSVAL(36308U) },
  { "UNSIGNED_INT_SAMPLER_2D_ARRAY", UINT_TO_JSVAL(36311U) },
  { "DEPTH_COMPONENT32F", UINT_TO_JSVAL(36012U) },
  { "DEPTH32F_STENCIL8", UINT_TO_JSVAL(36013U) },
  { "FLOAT_32_UNSIGNED_INT_24_8_REV", UINT_TO_JSVAL(36269U) },
  { "FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING", UINT_TO_JSVAL(33296U) },
  { "FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE", UINT_TO_JSVAL(33297U) },
  { "FRAMEBUFFER_ATTACHMENT_RED_SIZE", UINT_TO_JSVAL(33298U) },
  { "FRAMEBUFFER_ATTACHMENT_GREEN_SIZE", UINT_TO_JSVAL(33299U) },
  { "FRAMEBUFFER_ATTACHMENT_BLUE_SIZE", UINT_TO_JSVAL(33300U) },
  { "FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE", UINT_TO_JSVAL(33301U) },
  { "FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE", UINT_TO_JSVAL(33302U) },
  { "FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE", UINT_TO_JSVAL(33303U) },
  { "FRAMEBUFFER_DEFAULT", UINT_TO_JSVAL(33304U) },
  { "DEPTH_STENCIL_ATTACHMENT", UINT_TO_JSVAL(33306U) },
  { "DEPTH_STENCIL", UINT_TO_JSVAL(34041U) },
  { "UNSIGNED_INT_24_8", UINT_TO_JSVAL(34042U) },
  { "DEPTH24_STENCIL8", UINT_TO_JSVAL(35056U) },
  { "UNSIGNED_NORMALIZED", UINT_TO_JSVAL(35863U) },
  { "DRAW_FRAMEBUFFER_BINDING", UINT_TO_JSVAL(36006U) },
  { "READ_FRAMEBUFFER", UINT_TO_JSVAL(36008U) },
  { "DRAW_FRAMEBUFFER", UINT_TO_JSVAL(36009U) },
  { "READ_FRAMEBUFFER_BINDING", UINT_TO_JSVAL(36010U) },
  { "RENDERBUFFER_SAMPLES", UINT_TO_JSVAL(36011U) },
  { "FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER", UINT_TO_JSVAL(36052U) },
  { "MAX_COLOR_ATTACHMENTS", UINT_TO_JSVAL(36063U) },
  { "COLOR_ATTACHMENT1", UINT_TO_JSVAL(36065U) },
  { "COLOR_ATTACHMENT2", UINT_TO_JSVAL(36066U) },
  { "COLOR_ATTACHMENT3", UINT_TO_JSVAL(36067U) },
  { "COLOR_ATTACHMENT4", UINT_TO_JSVAL(36068U) },
  { "COLOR_ATTACHMENT5", UINT_TO_JSVAL(36069U) },
  { "COLOR_ATTACHMENT6", UINT_TO_JSVAL(36070U) },
  { "COLOR_ATTACHMENT7", UINT_TO_JSVAL(36071U) },
  { "COLOR_ATTACHMENT8", UINT_TO_JSVAL(36072U) },
  { "COLOR_ATTACHMENT9", UINT_TO_JSVAL(36073U) },
  { "COLOR_ATTACHMENT10", UINT_TO_JSVAL(36074U) },
  { "COLOR_ATTACHMENT11", UINT_TO_JSVAL(36075U) },
  { "COLOR_ATTACHMENT12", UINT_TO_JSVAL(36076U) },
  { "COLOR_ATTACHMENT13", UINT_TO_JSVAL(36077U) },
  { "COLOR_ATTACHMENT14", UINT_TO_JSVAL(36078U) },
  { "COLOR_ATTACHMENT15", UINT_TO_JSVAL(36079U) },
  { "FRAMEBUFFER_INCOMPLETE_MULTISAMPLE", UINT_TO_JSVAL(36182U) },
  { "MAX_SAMPLES", UINT_TO_JSVAL(36183U) },
  { "HALF_FLOAT", UINT_TO_JSVAL(5131U) },
  { "RG", UINT_TO_JSVAL(33319U) },
  { "RG_INTEGER", UINT_TO_JSVAL(33320U) },
  { "R8", UINT_TO_JSVAL(33321U) },
  { "RG8", UINT_TO_JSVAL(33323U) },
  { "R16F", UINT_TO_JSVAL(33325U) },
  { "R32F", UINT_TO_JSVAL(33326U) },
  { "RG16F", UINT_TO_JSVAL(33327U) },
  { "RG32F", UINT_TO_JSVAL(33328U) },
  { "R8I", UINT_TO_JSVAL(33329U) },
  { "R8UI", UINT_TO_JSVAL(33330U) },
  { "R16I", UINT_TO_JSVAL(33331U) },
  { "R16UI", UINT_TO_JSVAL(33332U) },
  { "R32I", UINT_TO_JSVAL(33333U) },
  { "R32UI", UINT_TO_JSVAL(33334U) },
  { "RG8I", UINT_TO_JSVAL(33335U) },
  { "RG8UI", UINT_TO_JSVAL(33336U) },
  { "RG16I", UINT_TO_JSVAL(33337U) },
  { "RG16UI", UINT_TO_JSVAL(33338U) },
  { "RG32I", UINT_TO_JSVAL(33339U) },
  { "RG32UI", UINT_TO_JSVAL(33340U) },
  { "VERTEX_ARRAY_BINDING", UINT_TO_JSVAL(34229U) },
  { "R8_SNORM", UINT_TO_JSVAL(36756U) },
  { "RG8_SNORM", UINT_TO_JSVAL(36757U) },
  { "RGB8_SNORM", UINT_TO_JSVAL(36758U) },
  { "RGBA8_SNORM", UINT_TO_JSVAL(36759U) },
  { "SIGNED_NORMALIZED", UINT_TO_JSVAL(36764U) },
  { "PRIMITIVE_RESTART_FIXED_INDEX", UINT_TO_JSVAL(36201U) },
  { "COPY_READ_BUFFER", UINT_TO_JSVAL(36662U) },
  { "COPY_WRITE_BUFFER", UINT_TO_JSVAL(36663U) },
  { "COPY_READ_BUFFER_BINDING", UINT_TO_JSVAL(36662U) },
  { "COPY_WRITE_BUFFER_BINDING", UINT_TO_JSVAL(36663U) },
  { "UNIFORM_BUFFER", UINT_TO_JSVAL(35345U) },
  { "UNIFORM_BUFFER_BINDING", UINT_TO_JSVAL(35368U) },
  { "UNIFORM_BUFFER_START", UINT_TO_JSVAL(35369U) },
  { "UNIFORM_BUFFER_SIZE", UINT_TO_JSVAL(35370U) },
  { "MAX_VERTEX_UNIFORM_BLOCKS", UINT_TO_JSVAL(35371U) },
  { "MAX_FRAGMENT_UNIFORM_BLOCKS", UINT_TO_JSVAL(35373U) },
  { "MAX_COMBINED_UNIFORM_BLOCKS", UINT_TO_JSVAL(35374U) },
  { "MAX_UNIFORM_BUFFER_BINDINGS", UINT_TO_JSVAL(35375U) },
  { "MAX_UNIFORM_BLOCK_SIZE", UINT_TO_JSVAL(35376U) },
  { "MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS", UINT_TO_JSVAL(35377U) },
  { "MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS", UINT_TO_JSVAL(35379U) },
  { "UNIFORM_BUFFER_OFFSET_ALIGNMENT", UINT_TO_JSVAL(35380U) },
  { "ACTIVE_UNIFORM_BLOCKS", UINT_TO_JSVAL(35382U) },
  { "UNIFORM_TYPE", UINT_TO_JSVAL(35383U) },
  { "UNIFORM_SIZE", UINT_TO_JSVAL(35384U) },
  { "UNIFORM_BLOCK_INDEX", UINT_TO_JSVAL(35386U) },
  { "UNIFORM_OFFSET", UINT_TO_JSVAL(35387U) },
  { "UNIFORM_ARRAY_STRIDE", UINT_TO_JSVAL(35388U) },
  { "UNIFORM_MATRIX_STRIDE", UINT_TO_JSVAL(35389U) },
  { "UNIFORM_IS_ROW_MAJOR", UINT_TO_JSVAL(35390U) },
  { "UNIFORM_BLOCK_BINDING", UINT_TO_JSVAL(35391U) },
  { "UNIFORM_BLOCK_DATA_SIZE", UINT_TO_JSVAL(35392U) },
  { "UNIFORM_BLOCK_ACTIVE_UNIFORMS", UINT_TO_JSVAL(35394U) },
  { "UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES", UINT_TO_JSVAL(35395U) },
  { "UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER", UINT_TO_JSVAL(35396U) },
  { "UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER", UINT_TO_JSVAL(35398U) },
  { "INVALID_INDEX", UINT_TO_JSVAL(4294967295U) },
  { "MAX_VERTEX_OUTPUT_COMPONENTS", UINT_TO_JSVAL(37154U) },
  { "MAX_FRAGMENT_INPUT_COMPONENTS", UINT_TO_JSVAL(37157U) },
  { "MAX_SERVER_WAIT_TIMEOUT", UINT_TO_JSVAL(37137U) },
  { "OBJECT_TYPE", UINT_TO_JSVAL(37138U) },
  { "SYNC_CONDITION", UINT_TO_JSVAL(37139U) },
  { "SYNC_STATUS", UINT_TO_JSVAL(37140U) },
  { "SYNC_FLAGS", UINT_TO_JSVAL(37141U) },
  { "SYNC_FENCE", UINT_TO_JSVAL(37142U) },
  { "SYNC_GPU_COMMANDS_COMPLETE", UINT_TO_JSVAL(37143U) },
  { "UNSIGNALED", UINT_TO_JSVAL(37144U) },
  { "SIGNALED", UINT_TO_JSVAL(37145U) },
  { "ALREADY_SIGNALED", UINT_TO_JSVAL(37146U) },
  { "TIMEOUT_EXPIRED", UINT_TO_JSVAL(37147U) },
  { "CONDITION_SATISFIED", UINT_TO_JSVAL(37148U) },
  { "WAIT_FAILED", UINT_TO_JSVAL(37149U) },
  { "SYNC_FLUSH_COMMANDS_BIT", UINT_TO_JSVAL(1U) },
  { "VERTEX_ATTRIB_ARRAY_DIVISOR", UINT_TO_JSVAL(35070U) },
  { "ANY_SAMPLES_PASSED", UINT_TO_JSVAL(35887U) },
  { "ANY_SAMPLES_PASSED_CONSERVATIVE", UINT_TO_JSVAL(36202U) },
  { "SAMPLER_BINDING", UINT_TO_JSVAL(35097U) },
  { "RGB10_A2UI", UINT_TO_JSVAL(36975U) },
  { "TEXTURE_SWIZZLE_R", UINT_TO_JSVAL(36418U) },
  { "TEXTURE_SWIZZLE_G", UINT_TO_JSVAL(36419U) },
  { "TEXTURE_SWIZZLE_B", UINT_TO_JSVAL(36420U) },
  { "TEXTURE_SWIZZLE_A", UINT_TO_JSVAL(36421U) },
  { "GREEN", UINT_TO_JSVAL(6404U) },
  { "BLUE", UINT_TO_JSVAL(6405U) },
  { "INT_2_10_10_10_REV", UINT_TO_JSVAL(36255U) },
  { "TRANSFORM_FEEDBACK", UINT_TO_JSVAL(36386U) },
  { "TRANSFORM_FEEDBACK_PAUSED", UINT_TO_JSVAL(36387U) },
  { "TRANSFORM_FEEDBACK_ACTIVE", UINT_TO_JSVAL(36388U) },
  { "TRANSFORM_FEEDBACK_BINDING", UINT_TO_JSVAL(36389U) },
  { "COMPRESSED_R11_EAC", UINT_TO_JSVAL(37488U) },
  { "COMPRESSED_SIGNED_R11_EAC", UINT_TO_JSVAL(37489U) },
  { "COMPRESSED_RG11_EAC", UINT_TO_JSVAL(37490U) },
  { "COMPRESSED_SIGNED_RG11_EAC", UINT_TO_JSVAL(37491U) },
  { "COMPRESSED_RGB8_ETC2", UINT_TO_JSVAL(37492U) },
  { "COMPRESSED_SRGB8_ETC2", UINT_TO_JSVAL(37493U) },
  { "COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2", UINT_TO_JSVAL(37494U) },
  { "COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2", UINT_TO_JSVAL(37495U) },
  { "COMPRESSED_RGBA8_ETC2_EAC", UINT_TO_JSVAL(37496U) },
  { "COMPRESSED_SRGB8_ALPHA8_ETC2_EAC", UINT_TO_JSVAL(37497U) },
  { "TEXTURE_IMMUTABLE_FORMAT", UINT_TO_JSVAL(37167U) },
  { "MAX_ELEMENT_INDEX", UINT_TO_JSVAL(36203U) },
  { "NUM_SAMPLE_COUNTS", UINT_TO_JSVAL(37760U) },
  { "TEXTURE_IMMUTABLE_LEVELS", UINT_TO_JSVAL(33503U) },
  { "TIMEOUT_IGNORED", DOUBLE_TO_JSVAL(-1LL) },
  { 0, JS::UndefinedValue() }
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const ConstantSpec> sConstants[] = {
  { true, nullptr, nullptr, nullptr, &sConstants_specs[0] },
  { false, nullptr }
};

static jsid sConstants_ids[283];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sConstants, sConstants_ids, sConstants_specs,
  -1
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, nullptr },
  prototypes::id::WebGL2RenderingContext,
  constructors::id::WebGL2RenderingContext,
  WebGLRenderingContextBinding::sNativePropertyHooks
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function WebGL2RenderingContext() {\n    [native code]\n}",
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  WebGLRenderingContextBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "WebGL2RenderingContextPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object WebGL2RenderingContextPrototype]",
  prototypes::id::WebGL2RenderingContext,
  PrototypeTraits<prototypes::id::WebGL2RenderingContext>::Depth,
  WebGLRenderingContextBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("webgl.enable-prototype-webgl2");
}

static const DOMJSClass Class = {
  { "WebGL2RenderingContext",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::WebGLRenderingContext, prototypes::id::WebGL2RenderingContext, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::WebGL2Context >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::WebGL2Context>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::WebGL2Context>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::WebGL2Context* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::WebGL2Context*>(aObject) ==
             reinterpret_cast<mozilla::WebGL2Context*>(aObject),
             "Multiple inheritance for mozilla::WebGL2Context is broken.");
  MOZ_ASSERT(static_cast<mozilla::WebGLContext*>(aObject) ==
             reinterpret_cast<mozilla::WebGLContext*>(aObject),
             "Multiple inheritance for mozilla::WebGLContext is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
    MOZ_ASSERT(!aGivenProto,
               "How are we supposed to change the proto now?");
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::WebGL2Context> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();
  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(WebGLRenderingContextBinding::GetProtoObjectHandle(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(WebGLRenderingContextBinding::GetConstructorObjectHandle(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sConstants, sConstants_ids)) {
      return;
    }
    sIdsInited = true;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::WebGL2RenderingContext);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::WebGL2RenderingContext);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              &sNativeProperties,
                              nullptr,
                              "WebGL2RenderingContext", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::WebGL2RenderingContext)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::WebGL2RenderingContext).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::WebGL2RenderingContext)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::WebGL2RenderingContext).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace WebGL2RenderingContextBinding



namespace WebGLQueryBinding {

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::WebGLQuery* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLQuery>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::WebGLQuery* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLQuery>(obj);
  if (self) {
    JSBindingFinalized<mozilla::WebGLQuery>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::WebGLQuery>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::WebGLQuery* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLQuery>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { nullptr, nullptr },
  prototypes::id::WebGLQuery,
  constructors::id::WebGLQuery,
  nullptr
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function WebGLQuery() {\n    [native code]\n}",
  prototypes::id::WebGLQuery,
  PrototypeTraits<prototypes::id::WebGLQuery>::Depth,
  JS_GetFunctionPrototype
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "WebGLQueryPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object WebGLQueryPrototype]",
  prototypes::id::WebGLQuery,
  PrototypeTraits<prototypes::id::WebGLQuery>::Depth,
  JS_GetObjectPrototype
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("webgl.enable-prototype-webgl2");
}

static const DOMJSClass Class = {
  { "WebGLQuery",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::WebGLQuery, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::WebGLQuery >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::WebGLQuery>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::WebGLQuery>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::WebGLQuery* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::WebGLQuery*>(aObject) ==
             reinterpret_cast<mozilla::WebGLQuery*>(aObject),
             "Multiple inheritance for mozilla::WebGLQuery is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
    MOZ_ASSERT(!aGivenProto,
               "How are we supposed to change the proto now?");
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::WebGLQuery> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();
  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Rooted<JSObject*> parentProto(aCx, JS_GetObjectPrototype(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Rooted<JSObject*> constructorProto(aCx, JS_GetFunctionPrototype(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::WebGLQuery);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::WebGLQuery);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              nullptr,
                              nullptr,
                              "WebGLQuery", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::WebGLQuery)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::WebGLQuery).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::WebGLQuery)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::WebGLQuery).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace WebGLQueryBinding



namespace WebGLSamplerBinding {

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::WebGLSampler* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLSampler>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::WebGLSampler* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLSampler>(obj);
  if (self) {
    JSBindingFinalized<mozilla::WebGLSampler>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::WebGLSampler>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::WebGLSampler* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLSampler>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { nullptr, nullptr },
  prototypes::id::WebGLSampler,
  constructors::id::WebGLSampler,
  nullptr
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function WebGLSampler() {\n    [native code]\n}",
  prototypes::id::WebGLSampler,
  PrototypeTraits<prototypes::id::WebGLSampler>::Depth,
  JS_GetFunctionPrototype
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "WebGLSamplerPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object WebGLSamplerPrototype]",
  prototypes::id::WebGLSampler,
  PrototypeTraits<prototypes::id::WebGLSampler>::Depth,
  JS_GetObjectPrototype
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("webgl.enable-prototype-webgl2");
}

static const DOMJSClass Class = {
  { "WebGLSampler",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::WebGLSampler, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::WebGLSampler >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::WebGLSampler>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::WebGLSampler>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::WebGLSampler* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::WebGLSampler*>(aObject) ==
             reinterpret_cast<mozilla::WebGLSampler*>(aObject),
             "Multiple inheritance for mozilla::WebGLSampler is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
    MOZ_ASSERT(!aGivenProto,
               "How are we supposed to change the proto now?");
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::WebGLSampler> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();
  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Rooted<JSObject*> parentProto(aCx, JS_GetObjectPrototype(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Rooted<JSObject*> constructorProto(aCx, JS_GetFunctionPrototype(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::WebGLSampler);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::WebGLSampler);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              nullptr,
                              nullptr,
                              "WebGLSampler", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::WebGLSampler)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::WebGLSampler).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::WebGLSampler)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::WebGLSampler).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace WebGLSamplerBinding



namespace WebGLSyncBinding {

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::WebGLSync* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLSync>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::WebGLSync* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLSync>(obj);
  if (self) {
    JSBindingFinalized<mozilla::WebGLSync>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::WebGLSync>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::WebGLSync* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLSync>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { nullptr, nullptr },
  prototypes::id::WebGLSync,
  constructors::id::WebGLSync,
  nullptr
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function WebGLSync() {\n    [native code]\n}",
  prototypes::id::WebGLSync,
  PrototypeTraits<prototypes::id::WebGLSync>::Depth,
  JS_GetFunctionPrototype
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "WebGLSyncPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object WebGLSyncPrototype]",
  prototypes::id::WebGLSync,
  PrototypeTraits<prototypes::id::WebGLSync>::Depth,
  JS_GetObjectPrototype
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("webgl.enable-prototype-webgl2");
}

static const DOMJSClass Class = {
  { "WebGLSync",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::WebGLSync, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::WebGLSync >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::WebGLSync>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::WebGLSync>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::WebGLSync* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::WebGLSync*>(aObject) ==
             reinterpret_cast<mozilla::WebGLSync*>(aObject),
             "Multiple inheritance for mozilla::WebGLSync is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
    MOZ_ASSERT(!aGivenProto,
               "How are we supposed to change the proto now?");
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::WebGLSync> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();
  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Rooted<JSObject*> parentProto(aCx, JS_GetObjectPrototype(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Rooted<JSObject*> constructorProto(aCx, JS_GetFunctionPrototype(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::WebGLSync);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::WebGLSync);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              nullptr,
                              nullptr,
                              "WebGLSync", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::WebGLSync)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::WebGLSync).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::WebGLSync)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::WebGLSync).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace WebGLSyncBinding



namespace WebGLTransformFeedbackBinding {

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::WebGLTransformFeedback* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLTransformFeedback>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::WebGLTransformFeedback* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLTransformFeedback>(obj);
  if (self) {
    JSBindingFinalized<mozilla::WebGLTransformFeedback>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::WebGLTransformFeedback>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::WebGLTransformFeedback* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::WebGLTransformFeedback>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { nullptr, nullptr },
  prototypes::id::WebGLTransformFeedback,
  constructors::id::WebGLTransformFeedback,
  nullptr
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function WebGLTransformFeedback() {\n    [native code]\n}",
  prototypes::id::WebGLTransformFeedback,
  PrototypeTraits<prototypes::id::WebGLTransformFeedback>::Depth,
  JS_GetFunctionPrototype
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "WebGLTransformFeedbackPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object WebGLTransformFeedbackPrototype]",
  prototypes::id::WebGLTransformFeedback,
  PrototypeTraits<prototypes::id::WebGLTransformFeedback>::Depth,
  JS_GetObjectPrototype
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("webgl.enable-prototype-webgl2");
}

static const DOMJSClass Class = {
  { "WebGLTransformFeedback",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::WebGLTransformFeedback, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::WebGLTransformFeedback >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::WebGLTransformFeedback>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::WebGLTransformFeedback>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::WebGLTransformFeedback* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::WebGLTransformFeedback*>(aObject) ==
             reinterpret_cast<mozilla::WebGLTransformFeedback*>(aObject),
             "Multiple inheritance for mozilla::WebGLTransformFeedback is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
    MOZ_ASSERT(!aGivenProto,
               "How are we supposed to change the proto now?");
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::WebGLTransformFeedback> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();
  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Rooted<JSObject*> parentProto(aCx, JS_GetObjectPrototype(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Rooted<JSObject*> constructorProto(aCx, JS_GetFunctionPrototype(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::WebGLTransformFeedback);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::WebGLTransformFeedback);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              nullptr,
                              nullptr,
                              "WebGLTransformFeedback", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::WebGLTransformFeedback)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::WebGLTransformFeedback).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::WebGLTransformFeedback)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::WebGLTransformFeedback).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace WebGLTransformFeedbackBinding



} // namespace dom
} // namespace mozilla
